package com.hcloud.microserver.bank;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.feign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 * @author xiezt
 */
@EnableAsync
@EnableDiscoveryClient
@EnableFeignClients(basePackages = {"com.hcloud.microserver"})
@EnableTransactionManagement
@ComponentScan(basePackages = "com.hcloud")
@MapperScan(basePackages = {"com.hcloud.microserver.bank.dao"})
@SpringBootApplication
public class CarbonManagerServiceApplication {

    public static void main(String[] args) {
        SpringApplication.run(CarbonManagerServiceApplication.class, args);
    }

}
