package com.hcloud.microserver.bank.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.bo.*;
import com.hcloud.microserver.bank.service.BankTransactionService;
import com.hcloud.microserver.bank.util.BankNoUtial;
import com.hcloud.microserver.bank.util.BankUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
@Slf4j
@Service
public class BankTransactionServiceImpl implements BankTransactionService {
    @Autowired
    private BankUtil bankUtil;
    @Override
    public CurrentAccountQueryResp currentAccountQuery(CurrentAccountQueryParam param) {

        if (param == null){
            return null;
        }
        String num = BankNoUtial.NextOrderNo();
        String time = bankUtil.getTime(new Date());
        String serviceId = "CL0003";
//        String sessionId="-1";
        BankLoginUserRespBO loginSession = bankUtil.getLoginSession();
        String sessionId = loginSession.getSessionId();

        BankQueryBaseParam<CurrentAccountQueryParam> paramReq = new BankQueryBaseParam<>();
        paramReq.setData(param);
        paramReq.setReqTime(time);
        paramReq.setServiceId(serviceId);
        paramReq.setSessionId(sessionId);
        paramReq.setSerialNo(num);
        CurrentAccountQueryResp currentAccountQueryResp =(CurrentAccountQueryResp) bankUtil.bankRequst(paramReq, 0, CurrentAccountQueryResp.class);
        log.info(JSONObject.toJSONString(currentAccountQueryResp));

        return currentAccountQueryResp;

    }

    @Override
    public CurrentAccountQueryDetailTotalResp currentAccountDetailQuery(CurrentAccountDetailQueryParam param) {
        if (param == null){
            return null;
        }
        String num = BankNoUtial.NextOrderNo();
        String time = bankUtil.getTime(new Date());
        String serviceId = "CL0004";
//        String sessionId="-1";
        BankLoginUserRespBO loginSession = bankUtil.getLoginSession();
        String sessionId = loginSession.getSessionId();

        BankQueryBaseParam<CurrentAccountDetailQueryParam> paramReq = new BankQueryBaseParam<>();
        paramReq.setData(param);
        paramReq.setReqTime(time);
        paramReq.setServiceId(serviceId);
        paramReq.setSessionId(sessionId);
        paramReq.setSerialNo(num);
        CurrentAccountQueryDetailTotalResp curDetailTotal =(CurrentAccountQueryDetailTotalResp) bankUtil.bankRequst(paramReq, 0, CurrentAccountQueryDetailTotalResp.class);
        log.info(JSONObject.toJSONString(curDetailTotal));
        return curDetailTotal;
    }

    @Override
    public IntrabankTransferResp intrabankTransfer(IntrabankTransferParam param) {
        if (param == null){
            return null;
        }
        String num = BankNoUtial.NextOrderNo();
        String time = bankUtil.getTime(new Date());
        String serviceId = "CL0004";
//        String sessionId="-1";
        BankLoginUserRespBO loginSession = bankUtil.getLoginSession();
        String sessionId = loginSession.getSessionId();

        BankQueryBaseParam<IntrabankTransferParam> paramReq = new BankQueryBaseParam<>();
        paramReq.setData(param);
        paramReq.setReqTime(time);
        paramReq.setServiceId(serviceId);
        paramReq.setSessionId(sessionId);
        paramReq.setSerialNo(num);
        IntrabankTransferResp intrabankTransferResp =(IntrabankTransferResp) bankUtil.bankRequst(paramReq, 1, IntrabankTransferResp.class);
        log.info(JSONObject.toJSONString(intrabankTransferResp));
        return intrabankTransferResp;

    }

    @Override
    public ReimbursementInstructionsDetailQueryResp reimbursementInstructionsDetailQuery(ReimbursementInstructionsDetailQueryParam param) {
        return null;
    }

    @Override
    public InquiryOfWithholdingInstructionDetailsResp inquiryOfWithholdingInstructionDetails(InquiryOfWithholdingInstructionDetailsParam param) {
        return null;
    }
}
