package com.hcloud.microserver.bank.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.bo.BankLoginUserReqParam;
import com.hcloud.microserver.bank.bo.BankLoginUserRespBO;
import com.hcloud.microserver.bank.bo.BankQueryBaseParam;
import com.hcloud.microserver.bank.service.BankUserService;
import com.hcloud.microserver.bank.util.BankNoUtial;
import com.hcloud.microserver.bank.util.BankUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;

import java.util.Date;

@Slf4j
@Service
public class BankUserServiceImpl implements BankUserService {



    @Autowired
    private BankUtil bankUtil;

    @Autowired
    private RedisTemplate redisTemplate;



    @Override
    public BankLoginUserRespBO loginUser(BankLoginUserReqParam reqBO) {
        if (reqBO == null){
            return null;
        }
        String num = BankNoUtial.NextOrderNo();
        String time = bankUtil.getTime(new Date());
        String serviceId = "CL0001";
        String sessionId="-1";
        BankQueryBaseParam<BankLoginUserReqParam> param = new BankQueryBaseParam<>();
        param.setData(reqBO);
        param.setReqTime(time);
        param.setServiceId(serviceId);
        param.setSessionId(sessionId);
        param.setSerialNo(num);
        BankLoginUserRespBO bankResponseBase =(BankLoginUserRespBO) bankUtil.bankRequst(param, 1, BankLoginUserRespBO.class);
        log.info(JSONObject.toJSONString(bankResponseBase));
        if ("00000000".equals(bankResponseBase.getRetCode())){
            bankUtil.cacheLoginSession(bankResponseBase);
        }
        return bankResponseBase;
    }
}
