package com.hcloud.microserver.bank.service.impl;

import com.hcloud.microserver.bank.service.SocketService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.net.Socket;

@Service
public class SocketServiceImpl implements SocketService {

    private String charset="UTF-8";

    @Value("${cqrcb.bank.sign.ip}")
    private String ip;

    @Value("${cqrcb.bank.sign.port}")
    private int port;

    @Override
    public String sendSignRequestTCP(String oriData) {
        StringBuffer sb = new StringBuffer("");
        Socket socket = null;
        BufferedInputStream in = null;
        BufferedOutputStream out = null;
        try {
            int length = oriData.getBytes(charset).length;
            byte[] buf = new byte[length + 5];
            String lenValue = String.valueOf(length);
            System.arraycopy(oriData.getBytes(charset), 0, buf, 5, length);
            for (int i = 0; i < 5; i++)
                buf[i] = '0';
            int idx = 0;
            for (int i = 5 - lenValue.length(); i < 5; i++) {
                buf[i] = (byte) lenValue.charAt(idx++);
            }
            socket = new Socket(ip, port);
            out = new BufferedOutputStream(socket.getOutputStream());
            out.write(buf);
            out.flush();
            in = new BufferedInputStream(socket.getInputStream());
            byte[] buffer = new byte[1024];
            int len = 0;
            while ((len = in.read(buffer)) != -1) {
                sb.append(new String(buffer, 0, len, charset));
            }
        } catch (Exception e) {
            sb = new StringBuffer("-1");
            e.printStackTrace();
        } finally {
            try {
                if (null != socket) {
                    socket.close();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                if (out != null)
                    out.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
            try {
                if (in != null)
                    in.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return sb.toString();
    }
}
