package com.hcloud.microserver.bank;

import cn.hutool.core.util.RandomUtil;
import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.bo.BankLoginUserReqParam;
import com.hcloud.microserver.bank.bo.CurrentAccountDetailQueryParam;
import com.hcloud.microserver.bank.bo.CurrentAccountQueryParam;
import com.hcloud.microserver.bank.bo.IntrabankTransferParam;
import com.hcloud.microserver.bank.service.BankTransactionService;
import com.hcloud.microserver.bank.service.SocketService;
import com.hcloud.microserver.bank.service.impl.BankUserServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringRunner;
import org.xml.sax.SAXException;

import java.io.IOException;
@Slf4j
@RunWith(SpringRunner.class)
@SpringBootTest(classes = {CarbonManagerServiceApplication.class})
public class BankSiginTest {

    @Autowired
    private SocketService socketService;

    @Autowired
    private BankUserServiceImpl bankUserServiceImpl;

    @Autowired
    private BankTransactionService bankTransactionService;

    @Test
    public void testPage() throws IOException, SAXException {

        BankLoginUserReqParam bo = new BankLoginUserReqParam();
//        bo.setUserPWD("3F7EC50B5E904191D2C6B02744C45CEC7EE95E99");
        bo.setUserPWD("E3B87EC1850E475490CBF623EEEA524AEA171A15");
        bo.setUserID("2720525548");
        bo.setSystemId("00001");
        bankUserServiceImpl.loginUser(bo);
//        Map<String, Object> requestMap = BankUtil.getRequestMap(bo);

//        JSONObject jsonObject = JSON.toJSON(requestMap);
//        String s1 = JSONObject.toJSONString(requestMap);
//        JSONObject json = (JSONObject) JSONObject.parse(s1);
//        String s = JsonAndXmlUtils.JsonToXml(json);
//
//        System.out.println(s);
//        String ss = socketService.sendSignRequestTCP(s);
//        System.out.println(ss);
    }

    @Test
    public void testCurrent(){
        CurrentAccountQueryParam cu = new CurrentAccountQueryParam();
        cu.setI1ACNO("5001010120010000062");
        bankTransactionService.currentAccountQuery(cu);
    }

    @Test
    public void testCurrentDetail(){
        CurrentAccountDetailQueryParam cu = new CurrentAccountDetailQueryParam();
        cu.setI1ACNO("5001010120010000062");
        cu.setI1STDT("20200101");
        cu.setI1EDDT("20201101");
        bankTransactionService.currentAccountDetailQuery(cu);
    }
    @Test
    public void testIntrabankTransfer(){
        IntrabankTransferParam param = new IntrabankTransferParam();
        String s = "CRB"+RandomUtil.randomNumbers(17);
        System.out.println(s);

    }
}
