package com.hcloud.microserver.facade.carbon.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.entity.BasePosition;
import com.hcloud.microserver.facade.carbon.fallback.impl.BasePositionFallback;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;

@FeignClient(name = "carbon-service", path = "/basePosition", fallbackFactory = BasePositionFallback.class)
public interface BasePositionClient {

    @PostMapping("/findByCodeAndLevel")
    ResultVO findByCodeAndLevel(@RequestBody BasePosition basePosition);

    @PostMapping("/findByCodes")
    ResultVO findByCodes(@RequestBody List<String> codes);

    @PostMapping("/findChongqingArea")
    ResultVO findChongqingArea(@RequestBody(required = false) BasePosition basePosition);
}
