package com.hcloud.microserver.facade.carbon.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.fallback.impl.CollectiveFarmerFallback;
import com.hcloud.microserver.facade.carbon.forms.CollectiveFarmerForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@FeignClient(name = "carbon-service", path = "/collectiveFarmer", fallbackFactory = CollectiveFarmerFallback.class)
public interface CollectiveFarmerClient {

    @PostMapping("/save")
    ResultVO save(@RequestBody CollectiveFarmerForm collectiveFarmerForm);

    @PostMapping("/delete")
    ResultVO delete(@RequestBody CollectiveFarmerForm collectiveFarmerForm);

    @PostMapping("/update")
    ResultVO update(@RequestBody CollectiveFarmerForm collectiveFarmerForm);

    @PostMapping("/searchByPage")
    ResultVO searchByPage(@RequestBody CollectiveFarmerForm collectiveFarmerForm);
}
