package com.hcloud.microserver.facade.carbon.client;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.fallback.impl.CompanyFallback;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@FeignClient(name = "carbon-service", path = "/company", fallbackFactory = CompanyFallback.class)
public interface CompanyClient {

    @PostMapping("/add")
    ResultVO addCompany(@RequestBody JSONObject jsonObject);

    @PostMapping("/update")
    ResultVO updateCompany(@RequestBody JSONObject jsonObject);

    @PostMapping("/delete")
    ResultVO deleteCompany(@RequestBody JSONObject jsonObject);
}
