package com.hcloud.microserver.facade.carbon.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.fallback.impl.OrderPayApplyFallback;
import com.hcloud.microserver.facade.carbon.forms.GoodsOrderInfoForm;
import com.hcloud.microserver.facade.carbon.forms.OrderPayApplyForm;
import com.hcloud.microserver.facade.carbon.forms.OrderPayVoucherForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.*;

/**
 * @author xiezt
 */
@FeignClient(name = "carbon-service", path = "/pay/apply", fallbackFactory = OrderPayApplyFallback.class)
public interface OrderPayApplyClient {

    /**
     * 分页查询离线支付申请信息
     * @param orderPayApplyForm
     * @return
     */
    @PostMapping("/searchByPage")
    ResultVO searchPayApplyByPage(@RequestBody OrderPayApplyForm orderPayApplyForm);

    /**
     * 更新离线支付申请信息
     * @param orderPayApplyForm
     * @return
     */
    @PostMapping("/updatePayApply")
    ResultVO updatePayApplyById(@RequestBody OrderPayApplyForm orderPayApplyForm);


    /**
     * 删除离线支付申请信息
     * @param guid
     * @return
     */
    @GetMapping("/delPayApply")
    ResultVO delPayApply(@RequestParam("guid") String guid);


    /**
     * 生成离线支付申请
     * @param goodsOrderInfoForm
     * @return
     */
    @PostMapping("/savePayApplyInfo")
    ResultVO savePayApplyInfo(@RequestBody GoodsOrderInfoForm goodsOrderInfoForm);


    /**
     * 生成离线支付凭证
     * @param payVoucherForm
     * @return
     */
    @PostMapping("/saveOffLienVoucher")
    ResultVO saveOffLienPayVoucher(@RequestBody OrderPayVoucherForm payVoucherForm);
}
