package com.hcloud.microserver.facade.carbon.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.fallback.impl.ProductTypeFallback;
import com.hcloud.microserver.facade.carbon.forms.ProductTypeForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = "carbon-service", path = "/productType", fallbackFactory = ProductTypeFallback.class)
public interface ProductTypeClient {

    @PostMapping("/save")
    ResultVO save(@RequestBody ProductTypeForm productTypeForm);

    @PostMapping("/delete")
    ResultVO delete(@RequestBody ProductTypeForm productTypeForm);

    @PostMapping("/update")
    ResultVO update(@RequestBody ProductTypeForm productTypeForm);

    @PostMapping("/searchByPage")
    ResultVO searchByPage(@RequestBody ProductTypeForm productTypeForm);

    @PostMapping("/expansions")
    ResultVO expansions(@RequestParam(name = "guid") String guid);

    @PostMapping("/all")
    ResultVO findAll(@RequestBody(required = false) ProductTypeForm productTypeForm);

    @PostMapping("/checkTypeVal")
    ResultVO checkTypeVal(@RequestParam(name = "typeVal") String typeVal);
}
