package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.CollectiveFarmerFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.CollectiveFarmerForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class CollectiveFarmerFallback implements FallbackFactory<CollectiveFarmerFallbackFactory> {
    @Override
    public CollectiveFarmerFallbackFactory create(Throwable throwable) {
        return new CollectiveFarmerFallbackFactory() {
            @Override
            public ResultVO save(CollectiveFarmerForm collectiveFarmerForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO delete(CollectiveFarmerForm collectiveFarmerForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO update(CollectiveFarmerForm collectiveFarmerForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchByPage(CollectiveFarmerForm collectiveFarmerForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
