package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.CompanyFallbackFactory;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class CompanyFallback implements FallbackFactory<CompanyFallbackFactory> {
    @Override
    public CompanyFallbackFactory create(Throwable cause) {
        return new CompanyFallbackFactory() {
            @Override
            public ResultVO addCompany(JSONObject jsonObject) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO updateCompany(JSONObject jsonObject) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO deleteCompany(JSONObject jsonObject) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
