package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.FarmerInfoFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.FarmerInfoForm;
import com.hcloud.microserver.facade.carbon.forms.PovertyAreaForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class FarmerInfoFallback implements FallbackFactory<FarmerInfoFallbackFactory> {
    @Override
    public FarmerInfoFallbackFactory create(Throwable throwable) {
        return new FarmerInfoFallbackFactory() {
            @Override
            public ResultVO save(FarmerInfoForm farmerInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO delete(FarmerInfoForm farmerInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO update(FarmerInfoForm farmerInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchByPage(FarmerInfoForm farmerInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 查询贫困区域(分页查询)
             *
             * @param povertyAreaForm
             * @return
             */
            @Override
            public ResultVO searchPovertyAreaByPage(PovertyAreaForm povertyAreaForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 通过贫困区域询贫困户信息
             *
             * @param farmerInfoForm
             * @return
             */
            @Override
            public ResultVO getFarmerInfoByAreaId(FarmerInfoForm farmerInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 查询贫困区域明细信息(含贫困户统计信息,贫困区域贫困户列表,贫困区域基本信息)
             *
             * @param areaId
             * @return
             */
            @Override
            public ResultVO getPovertyAreaById(String areaId) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchByProductGuid(String productGuid) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 获取农户明细信息
             *
             * @param farmerId
             * @return
             */
            @Override
            public ResultVO getFarmerInfoById(String farmerId) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchByCollectiveId(String collectiveId) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
