package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.GoodsInfoFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.FarmerInfoForm;
import com.hcloud.microserver.facade.carbon.forms.GoodsInfoForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author xiezt
 */
@Component
public class GoodsInfoFallback implements FallbackFactory<GoodsInfoFallbackFactory> {
    @Override
    public GoodsInfoFallbackFactory create(Throwable throwable) {
        return new GoodsInfoFallbackFactory() {
            @Override
            public ResultVO shelves(List<GoodsInfoForm> goodsInfoForms) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO delete(GoodsInfoForm goodsInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO update(GoodsInfoForm goodsInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchByPage(GoodsInfoForm goodsInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchJoinListByPage(GoodsInfoForm goodsInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 分页查询商品类型信息（移动端展示）
             *
             * @param goodsInfoForm
             * @return
             */
            @Override
            public ResultVO searchGoodsInfoByPage(GoodsInfoForm goodsInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 获取商品详情
             *
             * @param customerId
             * @return
             */
            @Override
            public ResultVO getGoodsInfoById(String customerId) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 根据需求碳汇量计算商品列表
             *
             * @param carbon
             * @return
             */
            @Override
            public ResultVO getGoodsInfoByCarbon(String carbon) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO updateGoods(JSONObject jsonObject) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 通过农户Id查询所属商品
             *
             * @param farmerInfoForm
             * @return
             */
            @Override
            public ResultVO getGoodsInfoByFarmerId(FarmerInfoForm farmerInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

        };
    }
}
