package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.PayApplyFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.OrderPayApplyForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class PayApplyFallback implements FallbackFactory<PayApplyFallbackFactory> {

    @Override
    public PayApplyFallbackFactory create(Throwable cause) {
        return new PayApplyFallbackFactory() {
            @Override
            public ResultVO searchByPage(OrderPayApplyForm orderPayApplyForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO audit(JSONObject jsonObject) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
