package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.ProductTypeFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.ProductTypeForm;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class ProductTypeFallback implements FallbackFactory<ProductTypeFallbackFactory> {
    @Override
    public ProductTypeFallbackFactory create(Throwable cause) {
        return new ProductTypeFallbackFactory() {
            @Override
            public ResultVO save(ProductTypeForm productTypeForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO delete(ProductTypeForm productTypeForm) {
                log.info("能不能收到RuntimeException: {}", cause.getMessage());
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO update(ProductTypeForm productTypeForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchByPage(ProductTypeForm productTypeForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO expansions(String guid) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO findAll(ProductTypeForm productTypeForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO checkTypeVal(String typeVal) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
