package com.hcloud.microserver.facade.carbon.forms;

import com.hcloud.microserver.commoncore.base.BaseForm;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @author xiezt
 */
@Data
public class GoodsOrderInfoForm extends BaseForm {

    private String guid;

    private String fkCustomerGuid;

    private String orderNo;

    private String customerName;

    private String customerType;

    private BigDecimal orderAmount;

    private BigDecimal orderCarbonAmount;

    private Integer orderStatus;

    /**
     * 交易方式
     */
    private String tradeType;
    /**
     * 订单支付流水编号
     */
    private String PayNo;

    /**
     * 商品订单详情
     */
    private List<GoodsOrderDetailForm> goodsOrderDetailForm;

    /**
     * 商品列表
     */
    private List<GoodsInfoForm> goodsList;
    /**
     * 支付渠道
     */
    private Integer payChannel;
    /**
     * 购买起始时间
     */
    private String beginDate;
    /**
     * 购买结束时间
     */
    private String endDate;
    /**
     * 客户账号
     */
    private String account;
    /**
     * 完成支付的支付流水信息
     */
    private GoodsPayOrderForm payOrderInfo;
    /**
     * 订单支付流水列表
     */
    private List<GoodsPayOrderForm> payOrderFormList;

    /**
     * 爱心用户信息
     */
    private CustomerInfoForm customerInfoForm;

    /**
     * 支付金额
     */
    private BigDecimal payAmount;

    /**
     * 购买时间
     */
    private Date createTime;
    /**
     * 证书编号
     */
    private String credentialNo;
    /**
     * 支付流水号
     */
    private String payNo;

    /**
     * 模糊查询条件
     */
    private String condition;

    /**
     * 离线支付申请备注
     */
    private String applyRemark;

    /**
     * 订单商品用途
     */
    private String goodsUse;
}
