package com.hcloud.microserver.facade.carbon.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.fallback.impl.PovertyAreaFallback;
import com.hcloud.microserver.facade.carbon.forms.PovertyAreaForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = "carbon-service", path = "/povertyArea", fallbackFactory = PovertyAreaFallback.class)
public interface PovertyAreaClient {

    @PostMapping("/searchByPage")
    ResultVO searchByPage(@RequestBody PovertyAreaForm povertyAreaForm);

    @PostMapping("/save")
    ResultVO save(@RequestBody PovertyAreaForm povertyAreaForm);

    @PostMapping("/update")
    ResultVO update(@RequestBody PovertyAreaForm povertyAreaForm);

    @PostMapping("/del")
    ResultVO del(@RequestBody PovertyAreaForm povertyAreaForm);

    @GetMapping("/findByGuid")
    ResultVO findByGuid(@RequestParam(name = "guid") String guid);
}
