package com.hcloud.microserver.facade.carbon.client;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.fallback.impl.ProductInfoFallback;
import com.hcloud.microserver.facade.carbon.forms.ProductInfoForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

@FeignClient(name = "carbon-service", path = "/product", fallbackFactory = ProductInfoFallback.class)
public interface ProductInfoClient {

    @PostMapping("/save")
    ResultVO save(@RequestBody ProductInfoForm productInfoForm);

    @PostMapping("/delete")
    ResultVO delete(@RequestBody ProductInfoForm productInfoForm);

    @PostMapping("/update")
    ResultVO update(@RequestBody ProductInfoForm productInfoForm);

    @PostMapping("/searchByPage")
    ResultVO searchByPage(@RequestBody ProductInfoForm productInfoForm);

    @PostMapping("/expansions")
    ResultVO expansions(@RequestParam(name = "guid") String guid);

    @PostMapping("/belongs")
    ResultVO belongs(@RequestParam(name = "guid") String guid);

    @PostMapping("/publish")
    ResultVO publish(@RequestBody JSONObject jsonObject);

    @PostMapping("/publishGoods")
    ResultVO publishGoods(@RequestBody JSONObject jsonObject);

    @PostMapping("/findByGoodsInfoGuid")
    ResultVO findByGoodsInfoGuid(@RequestParam("goodsInfoGuid") String goodsInfoGuid);
}
