package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.entity.BasePosition;
import com.hcloud.microserver.facade.carbon.fallback.BasePositionFallbackFactory;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;

@Slf4j
@Component
public class BasePositionFallback implements FallbackFactory<BasePositionFallbackFactory> {
    @Override
    public BasePositionFallbackFactory create(Throwable cause) {
        return new BasePositionFallbackFactory() {
            @Override
            public ResultVO findByCodeAndLevel(BasePosition basePosition) {
                log.error("/findByCodeAndLevel 熔断");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO findByCodes(List<String> codes) {
                log.error("findByCodes 熔断");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO findChongqingArea(BasePosition basePosition) {
                log.error("findChongqingArea 熔断");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
