package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.OrderPayApplyFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.GoodsOrderInfoForm;
import com.hcloud.microserver.facade.carbon.forms.OrderPayApplyForm;
import com.hcloud.microserver.facade.carbon.forms.OrderPayVoucherForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * @author xiezt
 */
@Component
public class OrderPayApplyFallback implements FallbackFactory<OrderPayApplyFallbackFactory> {

    @Override
    public OrderPayApplyFallbackFactory create(Throwable cause) {
        return new OrderPayApplyFallbackFactory(){
            /**
             * 分页查询离线支付申请信息
             *
             * @param orderPayApplyForm
             * @return
             */
            @Override
            public ResultVO searchPayApplyByPage(OrderPayApplyForm orderPayApplyForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 更新离线支付申请信息
             *
             * @param orderPayApplyForm
             * @return
             */
            @Override
            public ResultVO updatePayApplyById(OrderPayApplyForm orderPayApplyForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 删除离线支付申请信息
             *
             * @param guid
             * @return
             */
            @Override
            public ResultVO delPayApply(String guid) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 生成离线支付申请
             * @param orderInfoForm
             * @return
             */
            @Override
            public ResultVO savePayApplyInfo(GoodsOrderInfoForm orderInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 生成离线支付凭证
             *
             * @param payVoucherForm
             * @return
             */
            @Override
            public ResultVO saveOffLienPayVoucher(OrderPayVoucherForm payVoucherForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
