package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.OrderPayFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.GoodsPayOrderForm;
import com.hcloud.microserver.facade.carbon.forms.PaymentForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

/**
 * @author xiezt
 */
@Component
public class OrderPayFallback implements FallbackFactory<OrderPayFallbackFactory> {

    @Override
    public OrderPayFallbackFactory create(Throwable cause) {
        return new OrderPayFallbackFactory(){
            /**
             * 查询某订单，支付流水明细
             *
             * @param orderId
             * @return
             */
            @Override
            public ResultVO getOrderPayListByOrderId(String orderId) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 保存支付订单信息
             *
             * @param goodsPayOrderForm
             * @return
             */
            @Override
            public ResultVO savePayOrderInfo(GoodsPayOrderForm goodsPayOrderForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 更新支付订单明细
             *
             * @param goodsPayOrderForm
             * @return
             */
            @Override
            public ResultVO updateOrderPayInfo(GoodsPayOrderForm goodsPayOrderForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 通过支付订单编号查询支付信息
             *
             * @param payNo
             * @return
             */
            @Override
            public ResultVO getPayOrderInfoByPayNo(String payNo) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO queryPaymentByPage(PaymentForm paymentForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
