package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.PovertyAreaFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.PovertyAreaForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class PovertyAreaFallback implements FallbackFactory<PovertyAreaFallbackFactory> {
    @Override
    public PovertyAreaFallbackFactory create(Throwable cause) {
        return new PovertyAreaFallbackFactory() {
            @Override
            public ResultVO searchByPage(PovertyAreaForm povertyAreaForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO save(PovertyAreaForm povertyAreaForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO update(PovertyAreaForm povertyAreaForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO del(PovertyAreaForm povertyAreaForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO findByGuid(String guid) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
