package com.hcloud.microserver.facade.carbon.fallback.impl;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.fallback.ProductInfoFallbackFactory;
import com.hcloud.microserver.facade.carbon.forms.ProductInfoForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class ProductInfoFallback implements FallbackFactory<ProductInfoFallbackFactory> {
    @Override
    public ProductInfoFallbackFactory create(Throwable throwable) {
        return new ProductInfoFallbackFactory() {
            @Override
            public ResultVO save(ProductInfoForm productInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO delete(ProductInfoForm productInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO update(ProductInfoForm productInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO searchByPage(ProductInfoForm productInfoForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO expansions(String guid) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO belongs(String guid) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO publish(JSONObject jsonObject) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO publishGoods(JSONObject jsonObject) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO findByGoodsInfoGuid(String goodsInfoGuid) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
