package com.hcloud.microserver.bank.controller;

import com.hcloud.microserver.bank.service.BasePositionService;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.BasePositionClient;
import com.hcloud.microserver.facade.carbon.entity.BasePosition;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author xiezt
 */
@Slf4j
@RestController
@RequestMapping("/basePosition")
public class BasePositionManageController extends BaseController implements BasePositionClient {

    @Autowired
    private BasePositionService basePositionService;

    @PostMapping("/findByCodeAndLevel")
    @Override
    public ResultVO findByCodeAndLevel(@RequestBody BasePosition basePosition) {
        List<BasePosition> positionList = this.basePositionService.queryByCodeAndLevel(basePosition);
        return success(positionList);
    }

    @Override
    @PostMapping("/findByCodes")
    public ResultVO findByCodes(@RequestBody List<String> codes) {
        log.info("list string codes ===============> {}", codes);
        List<BasePosition> positionList = this.basePositionService.queryByCodes(codes);
        return success(positionList);
    }

    @Override
    @PostMapping("/findChongqingArea")
    public ResultVO findChongqingArea(@RequestBody(required = false) BasePosition basePosition) {
        List<BasePosition> positionList = this.basePositionService.queryByChongqingArea(basePosition);
        return success(positionList);
    }
}
