package com.hcloud.microserver.bank.controller;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.bank.service.CollectiveFarmerService;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.client.CollectiveFarmerClient;
import com.hcloud.microserver.facade.carbon.forms.CollectiveFarmerForm;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Objects;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/collectiveFarmer")
public class CollectiveFarmerManageController extends BaseController implements CollectiveFarmerClient {

    @Autowired
    private CollectiveFarmerService collectiveFarmerService;

    @Override
    @PostMapping("/save")
    public ResultVO save(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        int success = this.collectiveFarmerService.save(collectiveFarmerForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @Override
    @PostMapping("/delete")
    public ResultVO delete(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        int success = this.collectiveFarmerService.softRemove(collectiveFarmerForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @Override
    @PostMapping("/update")
    public ResultVO update(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        int success = this.collectiveFarmerService.modify(collectiveFarmerForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @Override
    @PostMapping("/searchByPage")
    public ResultVO searchByPage(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        PageInfo pageInfo = this.collectiveFarmerService.queryListByPage(collectiveFarmerForm);
        if (Objects.isNull(pageInfo)){ return success(null, 0);}
        return success(pageInfo.getList(), pageInfo.getTotal());
    }
}
