package com.hcloud.microserver.bank.controller;

import com.hcloud.microserver.bank.service.OrderDetailInfoService;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.OrderDetailClient;
import com.hcloud.microserver.facade.carbon.entity.GoodsOrderDetail;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/orderDetail")
public class OrderDetailManageController extends BaseController implements OrderDetailClient {

    @Autowired
    private OrderDetailInfoService orderDetailInfoService;

    @Override
    @PostMapping("/searchByOrderGuid")
    public ResultVO searchByOrderGuid(@RequestParam(name = "orderGuid") String orderGuid) {
        List<GoodsOrderDetail> goodsOrderDetails = this.orderDetailInfoService.findByGoodsOrderInfoGuid(orderGuid);
        return success(goodsOrderDetails);
    }
}
