package com.hcloud.microserver.bank.controller;

import com.alibaba.fastjson.JSONObject;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.bank.service.OrderPayApplyService;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.util.BeanCopyUtil;
import com.hcloud.microserver.facade.carbon.client.PayApplyClient;
import com.hcloud.microserver.facade.carbon.entity.GoodsOrderInfo;
import com.hcloud.microserver.facade.carbon.entity.OrderPayApply;
import com.hcloud.microserver.facade.carbon.forms.GoodsOrderInfoForm;
import com.hcloud.microserver.facade.carbon.forms.OrderPayApplyForm;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Objects;

@RestController
@RequestMapping("/payApply")
public class PayApplyManageController extends BaseController implements PayApplyClient {

    @Autowired
    private OrderPayApplyService orderPayApplyService;

    @Override
    @PostMapping("/searchByPage")
    public ResultVO searchByPage(@RequestBody OrderPayApplyForm orderPayApplyForm) {
        PageInfo pageInfo = this.orderPayApplyService.searchByPage(orderPayApplyForm);
        if (Objects.isNull(pageInfo)) {
            return success(null, 0);
        }
        return success(pageInfo.getList(), pageInfo.getTotal());
    }

    @Override
    @PostMapping("/audit")
    public ResultVO audit(@RequestBody JSONObject jsonObject) {
        GoodsOrderInfoForm goodsOrderInfoForm = jsonObject.getObject("goodsOrderInfoForm", GoodsOrderInfoForm.class);
        OrderPayApplyForm orderPayApplyForm = jsonObject.getObject("orderPayApplyForm", OrderPayApplyForm.class);
        GoodsOrderInfo goodsOrderInfo = BeanCopyUtil.convertBean(goodsOrderInfoForm, GoodsOrderInfo.class);
        OrderPayApply orderPayApply = BeanCopyUtil.convertBean(orderPayApplyForm, OrderPayApply.class);
        int success = this.orderPayApplyService.audit(orderPayApply, goodsOrderInfo);
        if (success > 0) return success();
        return failure();
    }
}
