package com.hcloud.microserver.bank.controller;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.bank.service.OrderPayVoucherService;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.PayVoucherClient;
import com.hcloud.microserver.facade.carbon.forms.OrderPayVoucherForm;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.Objects;

@RestController
@RequestMapping("/voucher")
public class PayVoucherManageController extends BaseController implements PayVoucherClient {

    @Autowired
    private OrderPayVoucherService orderPayVoucherService;

    @Override
    @PostMapping("/searchByPage")
    public ResultVO searchByPage(OrderPayVoucherForm orderPayVoucherForm) {
        PageInfo pageInfo = this.orderPayVoucherService.queryListByPage(orderPayVoucherForm);
        if (Objects.isNull(pageInfo)) {
            return success(null, 0);
        }
        return success(pageInfo.getList(), pageInfo.getTotal());

    }
}
