package com.hcloud.microserver.bank.controller;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.bank.service.PovertyAreaService;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.facade.carbon.client.PovertyAreaClient;
import com.hcloud.microserver.facade.carbon.entity.PovertyArea;
import com.hcloud.microserver.facade.carbon.forms.PovertyAreaForm;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Objects;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/povertyArea")
public class PovertyAreaManageController extends BaseController implements PovertyAreaClient {

    @Autowired
    private PovertyAreaService povertyAreaService;

    @PostMapping("/searchByPage")
    @Override
    public ResultVO searchByPage(@RequestBody PovertyAreaForm povertyAreaForm) {
        PageInfo pageInfo = this.povertyAreaService.queryListByPage(povertyAreaForm);
        if (Objects.isNull(pageInfo)) return success(null, 0);
        return success(pageInfo.getList(), pageInfo.getTotal());
    }

    @PostMapping("/save")
    @Override
    public ResultVO save(@RequestBody PovertyAreaForm povertyAreaForm) {
        int success = this.povertyAreaService.save(povertyAreaForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @PostMapping("/update")
    @Override
    public ResultVO update(@RequestBody PovertyAreaForm povertyAreaForm) {
        int success = this.povertyAreaService.modify(povertyAreaForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @PostMapping("/del")
    @Override
    public ResultVO del(@RequestBody PovertyAreaForm povertyAreaForm) {
        int success = this.povertyAreaService.remove(povertyAreaForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @Override
    @GetMapping("/findByGuid")
    public ResultVO findByGuid(@RequestParam(name = "guid") String guid) {
        PovertyArea povertyArea = this.povertyAreaService.findByGuid(guid);
        return success(povertyArea);
    }
}
