package com.hcloud.microserver.bank.controller;

import com.hcloud.microserver.facade.carbon.entity.DayCarbonBO;
import com.hcloud.microserver.bank.service.WebIndexService;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.entity.GroupNumBO;
import com.hcloud.microserver.facade.carbon.entity.UserBuyBO;
import com.hcloud.microserver.facade.carbon.forms.DayCarbonFrom;
import com.hcloud.microserver.facade.carbon.forms.GroupNumFrom;
import com.hcloud.microserver.facade.carbon.forms.UserBuyFrom;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("/webindex")
public class WebIndexController extends BaseController {

    @Autowired
    private WebIndexService webIndexService;

    @ApiOperation("当日碳汇量")
    @PostMapping("/dayCarbon")
    public ResultVO dayCarbon(@RequestBody DayCarbonFrom dayCarbonFrom) {
        DayCarbonBO dayCarbonBO = webIndexService.dayCarbon(dayCarbonFrom);
        return success(dayCarbonBO);
    }

    @ApiOperation("统计用户购碳排名")
    @PostMapping("/userBuy")
    public ResultVO userBuy(@RequestBody(required = false) UserBuyFrom userBuyFrom) {
        List<UserBuyBO> dayCarbonBO = webIndexService.userBuy(userBuyFrom);
        return success(dayCarbonBO);
    }

    @ApiOperation("统计购买趋势")
    @PostMapping("/groupnum")
    public ResultVO GroupNum(@RequestBody(required = false) GroupNumFrom groupNumFrom) {
        List<GroupNumBO> dayCarbonBO = webIndexService.GroupNum(groupNumFrom);
        return success(dayCarbonBO);
    }
}
