package com.hcloud.microserver.bank.dao;

import com.hcloud.microserver.bank.bo.CustomerInfoBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.facade.carbon.entity.CustomerInfo;
import com.hcloud.microserver.facade.carbon.forms.CustomerInfoForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface CustomerInfoMapper extends BaseMapper<CustomerInfo,String> {

    /**
     * 分页查询爱心客户信息
     * @param pageBean
     * @return
     */
    List<CustomerInfoBO> searchCustomerByPage(PageBean<CustomerInfoForm> pageBean);

    /**
     * 通过账号查询用户信息
     * @param account
     * @return
     */
    CustomerInfo searchCustomerByAccount(String account);

    /**
     * 多条件查询爱心用户信息
     * @param queryStr
     * @return
     */
    CustomerInfo getCustomerByInfo(String queryStr);

    /**
     * 通过登录渠道号查询爱心用户信息
     * @param channelType
     * @param threeCode
     * @return
     */
    CustomerInfoBO getCustomerByThreeCode(@Param("channel") Integer channelType , @Param("code") String threeCode);

    /**
     * 获取统计用户购碳统计信息
     * @param customerId
     * @return
     */
    CustomerInfoBO getCustomerStatisticalInfo(@Param("cusId") String customerId);

}