package com.hcloud.microserver.bank.dao;

import com.github.pagehelper.Page;
import com.hcloud.microserver.bank.bo.FarmerInfoBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.facade.carbon.entity.FarmerInfo;
import com.hcloud.microserver.facade.carbon.forms.FarmerInfoForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @author xiezt
 */
public interface FarmerInfoMapper extends BaseMapper<FarmerInfo, String> {
    Page<Map> selectListByPage(FarmerInfoForm farmerInfoForm);

    int batchInsert(List<FarmerInfo> farmerInfos);

    int updateByCollectiveId(@Param("collectiveId") String collectiveId);

    int batchUpdate(@Param("farmerInfos") List<FarmerInfo> farmerInfos);

    List<FarmerInfo> selectByCollectiveId(@Param("collectiveId") String collectiveId);

    String getCurrentCode();

    List<FarmerInfo> selectByProductGuid(@Param("productGuid") String productGuid);

    /**
     * 查询农户信息通过贫困区域Id
     * @param povertyId
     * @return
     */
    List<FarmerInfo> getFarmerInfoByPovertyArea(@Param("povertyId") String povertyId);

    /**
     * 通过商品Id获取农户信息
     * @param goodsId
     * @return
     */
    List<FarmerInfoBO> getFarmerInfoByGoods(@Param("goodsId") String goodsId);

    
}