package com.hcloud.microserver.bank.dao;

import com.hcloud.microserver.bank.bo.CredentialInfoBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.facade.carbon.entity.GoodsCredentialInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface GoodsCredentialInfoMapper extends BaseMapper<GoodsCredentialInfo,String> {

    /**
     * 通过订单编号查询生成证书所需的农户信息
     * @param orderId
     * @return
     */
    List<CredentialInfoBO> getCredentialFarmerInfoByOrderId(@Param("orderId") String orderId);

    /**
     * 通过订单编号查询农户信息
     * @param orderId
     * @return
     */
    CredentialInfoBO getCredentialInfoByOrderId(@Param("orderId") String orderId);

    /**
     * 获取当前最大编码
     * @return
     */
    String getMaxCode();

    /**
     *  获取证书信息通过客户id
     * @param customerId
     * @return
     */
    List<GoodsCredentialInfo> getCredentialInfoByCustomerId(@Param("customerId") String customerId);
}