package com.hcloud.microserver.bank.dao;

import com.github.pagehelper.Page;
import com.hcloud.microserver.bank.bo.GoodsInfoBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.facade.carbon.entity.GoodsInfo;
import com.hcloud.microserver.facade.carbon.forms.GoodsInfoForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface GoodsInfoMapper extends BaseMapper<GoodsInfo,String> {

    Page selectListByPage(GoodsInfoForm goodsInfoForm);

    int batchUpdate(@Param("goodsInfos") List<GoodsInfo> goodsInfos);

    Page selectJoinListByPage(GoodsInfoForm goodsInfoForm);

    /**
     * 分页查询商品信息（用于移动页面商品展示）
     * @param pageBean
     * @return
     */
    List<GoodsInfoBO> searchGoodsInfoByPage(PageBean<GoodsInfoForm> pageBean);

    String getCurrentCode();

    /**
     * 通过农户Id查询农户所参与的碳汇商品
     * @param farmerId
     * @return
     */
    List<GoodsInfoBO> searchGoodsInfoByFarmerId(@Param("farmerId") String farmerId);

    /**
     * 按guid查询商品
     * @param guid
     * @return
     */
    GoodsInfo selectByGuid(@Param("guid") String guid);

    /**
     * 按产品类型的类型值查询是否还有上架商品
     * @param typeVal
     * @return
     */
    int selectGoodsCountByProductTypeValue(@Param("typeVal") String typeVal);

    /**
     * 按产品guid查询商品
     * @param productGuid
     * @return
     */
    List<GoodsInfo> selectGoodsInfoByProductGuid(@Param("productGuid") String productGuid);
}