package com.hcloud.microserver.bank.dao;

import com.hcloud.microserver.bank.bo.OrderInfoBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.facade.carbon.entity.GoodsOrderInfo;
import com.hcloud.microserver.facade.carbon.forms.GoodsOrderInfoForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface GoodsOrderInfoMapper extends BaseMapper<GoodsOrderInfo,String> {
    /**
     * 分页查询订单信息
     * @param pageBean
     * @return
     */
    List<OrderInfoBO> searchOrderInfoByPage(PageBean<GoodsOrderInfoForm> pageBean);

    /**
     * 通话爱心用户Id查询订单信息（分页查询）
     * @param customerId
     * @param orderStatus
     * @return
     */
    List<OrderInfoBO> searchOrderInfoByCustomerId(@Param("custId") String customerId,@Param("orderStatus") Integer orderStatus);

    /**
     * 通过订单编号查询订单信息
     * @param orderNo
     * @return
     */
    GoodsOrderInfo getOrderInfoByNo(@Param("orderNo") String orderNo);

    /**
     * 更新订单归属信息，即合并订单客户信息
     * @param oldCustomerId
     * @param newCustomerId
     * @return
     */
    int updateOrderBelongInfo(@Param("oldId") String oldCustomerId ,@Param("newId") String newCustomerId);
}