package com.hcloud.microserver.bank.dao;

import com.hcloud.microserver.bank.bo.PaymentBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.facade.carbon.entity.GoodsPayOrder;
import com.hcloud.microserver.facade.carbon.forms.PaymentForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface GoodsPayOrderMapper extends BaseMapper<GoodsPayOrder,String> {
    /**
     * 通过订单支付流水号，查询支付流水信息
     * @param payNo
     * @return
     */
    GoodsPayOrder getPayOrderByNo(String payNo);

    /**
     * 获取订单流水列表信息
     * @param orderId
     * @return
     */
    List<GoodsPayOrder> getPayOrderByOrderId(String orderId);

    /**
     * 更新支付订单流水归属信息
     * @param oldCustomerId
     * @param newCustomerId
     * @return
     */
    int updatePayOrderBelongInfo(@Param("oldId") String oldCustomerId,@Param("newId") String newCustomerId);

    /**
     * 对外提供支付数据
     * @param paymentForm
     * @return
     */
    List<PaymentBO> selectPaymentByPage(PaymentForm paymentForm);
}