package com.hcloud.microserver.bank.dao;

import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.facade.carbon.entity.GoodsSaleInfo;
import com.hcloud.microserver.facade.carbon.forms.GoodsSaleInfoForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface GoodsSaleInfoMapper extends BaseMapper<GoodsSaleInfo,String> {

    /**
     * 更新商品销售信息
     * @param goodsSaleInfoForm
     * @return
     */
    int updateSaleInfo(GoodsSaleInfoForm goodsSaleInfoForm);

    List<GoodsSaleInfo> selectByGoodsInfoGuid(@Param("goodsInfoGuid") String goodsInfoGuid);

    int deleteByGoodsInfoGuid(@Param("goodsInfoGuid") String goodsInfoGuid);

    /**
     * 通过商品Id查询商品销售信息
     * @param goodsId
     * @return
     */
    GoodsSaleInfo getGoodsSaleInfoByGoodsId(@Param("goodsId") String goodsId);
}