package com.hcloud.microserver.bank.dao;

import com.github.pagehelper.Page;
import com.hcloud.microserver.bank.bo.PayApplyInfoBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.facade.carbon.entity.OrderPayApply;
import com.hcloud.microserver.facade.carbon.forms.OrderPayApplyForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author xiezt
 */
public interface OrderPayApplyMapper extends BaseMapper<OrderPayApply,String> {
    /**
     * 分页查询离线支付申请记录
     * @param pageBean
     * @return
     */
    List<PayApplyInfoBO> searchPayApplyInfoByPage(PageBean<OrderPayApplyForm> pageBean);

    /**
     * 获取离线支付信息通过订单Id
     * @param orderId
     * @return
     */
    OrderPayApply getPayApplyInfoByOrderId(@Param("orderId") String orderId);

    /**
     * 分页查询离线支付审核
     * @param orderPayApplyForm
     * @return
     */
    Page selectListByPage(OrderPayApplyForm orderPayApplyForm);

    /**
     *
     * @param oldCustomerId
     * @param newCustomerId
     * @return
     */
    int updateOrderPayApplyBelongInfo(@Param("oldId") String oldCustomerId,@Param("newId") String newCustomerId);
}