package com.hcloud.microserver.bank.dao;

import com.github.pagehelper.Page;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.facade.carbon.entity.OrderPayVoucher;
import com.hcloud.microserver.facade.carbon.forms.OrderPayVoucherForm;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @author xiezt
 */
public interface OrderPayVoucherMapper extends BaseMapper<OrderPayVoucher,String> {

    /**
     * 获取离线支付凭证通过订单Id
     * @param orderId
     * @return
     */
    List<OrderPayVoucher> getPayVoucherInfoByOrderId(@Param("orderId") String orderId);

    Page<Map> selectListByPage(OrderPayVoucherForm orderPayVoucherForm);

    /**
     * 更新支付凭证信息的归属信息
     * @param oldCustomerId
     * @param newCustomerId
     * @return
     */
    int updatePayVoucherBelongInfo(@Param("oldId") String oldCustomerId,@Param("newId") String newCustomerId);
}