package com.hcloud.microserver.bank.dao;

import com.github.pagehelper.Page;
import com.hcloud.microserver.bank.bo.PovertyAreaBO;
import com.hcloud.microserver.commoncore.base.BaseMapper;
import com.hcloud.microserver.facade.carbon.entity.PovertyArea;
import com.hcloud.microserver.facade.carbon.forms.PovertyAreaForm;

import java.util.List;
import java.util.Map;

/**
 * @author xiezt
 */
public interface PovertyAreaMapper extends BaseMapper<PovertyArea, String> {

    /**
     * 分页查询贫困区域列表
     * @param povertyAreaForm
     * @return
     */
    Page<Map> selectPovertyAreaListByPage(PovertyAreaForm povertyAreaForm);

    /**
     * 贫困区域基本信息（包含：统计信息）
     * @param guid
     * @return
     */
    PovertyAreaBO getPovertyAreaAnalysis(String guid);

    /**
     * 条件查询
     * @param povertyArea
     * @return
     */
    List<PovertyArea> findByFiveIds(PovertyArea povertyArea);
}