package com.hcloud.microserver.bank.enums;

import lombok.Getter;

/**
 * @author JYJ
 * 用户登录渠道枚举
 */

@Getter
public enum LoginChannelEnum {
    /**
     * 微信登录
     */
    WECHAT_NAME("weChat",1),
    /**
     * 支付宝登录
     */
    ALIPAY_NAME("Alipay",2),
    /**
     * 腾讯QQ
     */
    QQ_NAME("TencentQQ",3),
    /**
     * 电子邮箱
     */
    EMAIL_NAME("E-mail",4);

    /**
     * 渠道名称
     */
    private String channelName;
    /**
     * 渠道类型
     */
    private Integer channelType;

    LoginChannelEnum(String channelName,Integer channelType){
        this.channelName=channelName;
        this.channelType=channelType;
    }

    public static String getChannelNameByType(int channelType) {
        for (LoginChannelEnum resultEnum : LoginChannelEnum.values()) {
            if (resultEnum.getChannelType()==channelType) {
                return resultEnum.channelName;
            }
        }
        return null;
    }
}
