package com.hcloud.microserver.bank.listens;

import com.hcloud.microserver.bank.events.CredentialInfoEvent;
import com.hcloud.microserver.bank.service.CredentialInfoService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.EventListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

/**
 * @author xiezt
 */
@Slf4j
@Component
public class BusinessListener {

    @Autowired
    private CredentialInfoService credentialInfoService;


    @Async
    @EventListener
    public void generateCredentialInfo(CredentialInfoEvent credentialInfoEvent){
            String orderId = credentialInfoEvent.getOrderId();
            int i = credentialInfoService.saveCredentialInfo(orderId);
            if(i==0){
                log.error("生成证书信息失败,请在订单管理中重新生成证书信息");
            }
    }

}
