package com.hcloud.microserver.bank.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.facade.carbon.forms.CustomerInfoForm;

/**
 * @author xiezt
 */
public interface CustomerInfoService extends BaseServie<CustomerInfoForm,String> {

    /**
     * 分页查询爱心用户信息
     * @param customerInfoForm
     * @return
     */
    PageInfo searchCustomerByPage(CustomerInfoForm customerInfoForm);

    /**
     * 通过Id查询爱心用户信息
     * @param customerId
     * @return
     */
    CustomerInfoForm getCustomerInfoById(String customerId);

    /**
     * 通过账号查询爱心用户信息
     * @param account
     * @return
     */
    CustomerInfoForm getCustomerInfoByAccount(String account);

    /**
     * 通过多条件查询爱心用户信息
     * @param queryStr
     * @return
     */
    CustomerInfoForm getCustomerInfoByInfo(String queryStr);

    /**
     * 通过登录渠道查询用户信息
     * @param channelType
     * @param threeCode
     * @return
     */
    CustomerInfoForm getCustomerInfoByChannelInfo( Integer channelType,String threeCode);


    /**
     * 通过登录渠道信息保存爱心用户
     * @param customerInfoForm
     * @return
     */
    int saveCustomerInfoByChannelInfo(CustomerInfoForm customerInfoForm);

    /**
     * 用户重置密码
     * @param customerInfoForm
     * @return
     */
    int resetPassword(CustomerInfoForm customerInfoForm);

    /**
     * 更新用户信息（含微信登录渠道，及微信编号信息）
     * @param customerInfoForm
     * @return
     */
    int updateCustomerInfoForWeChat(CustomerInfoForm customerInfoForm);

    /**
     * 更新用户订单信息，到新的用户名下
     * @param oldCustomerId
     * @param newCustomerId
     * @return
     */
    int changeCustomerOrderInfo(String oldCustomerId,String newCustomerId);

    /**
     * 绑定用户手机号
     * @param customerId
     * @param phone
     * @return
     */
    int bindCustomerPhone(String customerId,String phone);
}
