package com.hcloud.microserver.bank.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.facade.carbon.entity.FarmerInfo;
import com.hcloud.microserver.facade.carbon.forms.FarmerInfoForm;
import com.hcloud.microserver.facade.carbon.forms.PovertyAreaForm;

import java.math.BigDecimal;
import java.util.List;

/**
 * @author xiezt
 */
public interface FarmerInfoService extends BaseServie<FarmerInfo, String> {

    int save(FarmerInfoForm farmerInfoForm);

    int softRemove(FarmerInfoForm farmerInfoForm);

    int modify(FarmerInfoForm farmerInfoForm);

    PageInfo queryListByPage(FarmerInfoForm farmerInfoForm);

    int verify(FarmerInfoForm farmerInfoForm);

    int batchModify(List<FarmerInfoForm> farmerInfoForms);

    List<FarmerInfo> queryByCollectiveId(String collectiveId);

    List<FarmerInfo> queryByProductGuid(String productGuid);

    /**
     * 查询农户信息通过区域Id(分页查询)
     * @param farmerInfoForm
     * @return
     */
    PageInfo searchFarmerInfoByPovertyArea(FarmerInfoForm farmerInfoForm);

    /**
     * 查询扶贫区域内农户统计信息
     * @param povertyAreaId
     * @return
     */
    PovertyAreaForm getPovertyAreaAnalysis(String povertyAreaId);


    /**
     * 通过商品id及销售金额更新农户销售信息
     * @param saleAmount
     * @param goodsId
     * @return
     */
    int updateFarmerSaleInfoByGoodsId(BigDecimal saleAmount, String goodsId);



}
