package com.hcloud.microserver.bank.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.bank.bo.GoodsInfoBO;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.facade.carbon.entity.GoodsInfo;
import com.hcloud.microserver.facade.carbon.entity.GoodsSaleInfo;
import com.hcloud.microserver.facade.carbon.entity.ProductInfo;
import com.hcloud.microserver.facade.carbon.forms.FarmerInfoForm;
import com.hcloud.microserver.facade.carbon.forms.GoodsInfoForm;

import java.util.List;

public interface GoodsInfoService extends BaseServie<GoodsInfo, String> {

    int batchShelves(List<GoodsInfoForm> goodsInfoForms);

    int save(GoodsInfoForm goodsInfoForm);

    int remove(GoodsInfoForm goodsInfoForm);

    int modify(GoodsInfoForm goodsInfoForm);

    PageInfo queryListByPage(GoodsInfoForm goodsInfoForm);

    PageInfo queryJoinListByPage(GoodsInfoForm goodsInfoForm);

    PageInfo searchGoodsInfoByPage(GoodsInfoForm goodsInfoForm);

    GoodsInfoBO getGoodsInfoByGuid(String guid);

    /**
     * 通过需求碳汇量获取商品信息列表
     * @param carbon
     * @return
     */
    List<GoodsInfoForm> getGoodsInfoByCarbon(String carbon);

    int modifyGoods(GoodsInfo goodsInfo, GoodsSaleInfo goodsSaleInfo, List<ProductInfo> productInfos);
    /**
     * 通过农户Id查询农户所参与商品信息(分页查询)
     * @param farmerInfoForm
     * @return
     */
    PageInfo searchGoodsInfoByFarmerId(FarmerInfoForm farmerInfoForm);



}
