package com.hcloud.microserver.bank.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.facade.carbon.forms.GoodsOrderInfoForm;

/**
 * @author xiezt
 */
public interface OrderInfoService extends BaseServie<GoodsOrderInfoForm,String> {

    /**
     * 分页查询订单信息
     * @param goodsOrderInfoForm
     * @return
     */
    PageInfo searchOrderInfoByPage(GoodsOrderInfoForm goodsOrderInfoForm);

    /**
     * 通过用户Id查询订单信息(分页信息)
     * @param goodsOrderInfoForm
     * @return
     */
    PageInfo searchOrderInfoByCustomerId(GoodsOrderInfoForm goodsOrderInfoForm);

    /**
     * 获取订单信息
     * @param orderId
     * @return
     */
    GoodsOrderInfoForm getOrderInfoById(String orderId);

    /**
     * 逻辑删除订单
     * @param orderId
     * @return
     */
    int delOrderInfoByLogical(String orderId);

    /**
     * 统一下单(生成订单,订单详情,支付订单)
     * @param goodsOrderInfoForm
     * @return
     */
    String saveFullOrderInfo(GoodsOrderInfoForm goodsOrderInfoForm);

    /**
     * 支付成功后回调更新（订单信息，支付流水信息，证书信息）
     * @param payNo
     * @param state
     * @return
     */
    int updateFullOrderInfo(String payNo,Integer state);

    /**
     * 回滚订单信息
     * @param orderId
     * @return
     */
    int rollbackOrderInfo(String orderId);

    /**
     * 通过订单编号查询订单信息
     * @param orderNo
     * @return
     */
    GoodsOrderInfoForm getOrderInfoByNo(String orderNo);

    /**
     * 为离线支付申请生成订单信息
     * @param goodsOrderInfoForm
     * @return
     */
    GoodsOrderInfoForm saveOrderInfoForOffline(GoodsOrderInfoForm goodsOrderInfoForm);


}
