package com.hcloud.microserver.bank.service;

import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.facade.carbon.entity.GoodsOrderInfo;
import com.hcloud.microserver.facade.carbon.entity.OrderPayApply;
import com.hcloud.microserver.facade.carbon.forms.GoodsOrderInfoForm;
import com.hcloud.microserver.facade.carbon.forms.OrderPayApplyForm;

/**
 * @author xiezt
 */
public interface OrderPayApplyService extends BaseServie<OrderPayApplyForm,String> {

    /**
     * 分页查询离线支付申请信息
     * @param orderPayApplyForm
     * @return
     */
    PageInfo searchPayApplyInfoByPage(OrderPayApplyForm orderPayApplyForm);

    /**
     * 生成离线支付申请信息
     * @param orderInfoForm
     * @return
     */
    int savePayApplyInfo(GoodsOrderInfoForm orderInfoForm);

    /**
     * 查询离线支付申请信息，通过订单Id
     * @return
     */
    OrderPayApplyForm getPayApplyInfoByOrderId(String orderId);


    /**
     * 分页查询
     * @param orderPayApplyForm
     * @return
     */
    PageInfo searchByPage(OrderPayApplyForm orderPayApplyForm);

    /**
     * 审核离线支付
     * @param orderPayApply
     * @param goodsOrderInfo
     * @return
     */
    int audit(OrderPayApply orderPayApply, GoodsOrderInfo goodsOrderInfo);

}
