package com.hcloud.microserver.bank.service;

import com.hcloud.microserver.bank.bo.GoodsPayOrderBO;
import com.hcloud.microserver.bank.bo.PaymentBO;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.facade.carbon.forms.GoodsPayOrderForm;
import com.hcloud.microserver.facade.carbon.forms.PaymentForm;

import java.util.List;

/**
 * @author xiezt
 */
public interface OrderPayService extends BaseServie<GoodsPayOrderForm,String> {
    /**
     * 通过订单支付流水号，查询支付流水信息
     * @param payNo
     * @return
     */
    GoodsPayOrderForm getPayOrderByNo(String payNo);

    /**
     * 获取订单流水列表信息
     * @param orderId
     * @return
     */
    List<GoodsPayOrderBO> getPayOrderByOrderId(String orderId);

    /**
     * 对外提供的支付数据
     * @param paymentForm
     * @return
     */
    List<PaymentBO> queryPaymentByPage(PaymentForm paymentForm);
}
