package com.hcloud.microserver.bank.service.impl;

import com.hcloud.microserver.bank.dao.CustomerCompanyInfoMapper;
import com.hcloud.microserver.bank.dao.CustomerInfoMapper;
import com.hcloud.microserver.bank.service.CompanyService;
import com.hcloud.microserver.bank.service.CustomerCompanyInfoService;
import com.hcloud.microserver.commoncore.util.Md5Util;
import com.hcloud.microserver.commoncore.util.TracedCodeUtils;
import com.hcloud.microserver.commoncore.util.UUIDUtils;
import com.hcloud.microserver.facade.carbon.entity.CustomerCompanyInfo;
import com.hcloud.microserver.facade.carbon.entity.CustomerInfo;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;

@Service
public class CompanyServiceImpl implements CompanyService {

    @Resource
    private CustomerInfoMapper customerInfoMapper;

    @Resource
    private CustomerCompanyInfoMapper customerCompanyInfoMapper;

    @Override
    public int saveCompany(CustomerInfo customerInfo, CustomerCompanyInfo customerCompanyInfo) {
        int result = 0;

        String customerGuid = UUIDUtils.randomUUID();
        customerInfo.setAccount(TracedCodeUtils.getCommonRandomCode());
        customerInfo.setPasswd(Md5Util.toMD5("000000"));
        customerInfo.setState(1);
        customerInfo.setIsEnable(1);
        customerInfo.setGuid(customerGuid);
        customerInfo.setIsCompany(1);
        customerInfo.setCreateTime(new Date());
        customerInfo.setModifiedTime(new Date());

        customerCompanyInfo.setGuid(UUIDUtils.randomUUID());
        customerCompanyInfo.setFkCustomerId(customerGuid);
        customerCompanyInfo.setCreateTime(new Date());
        customerCompanyInfo.setModifiedTime(new Date());
        customerCompanyInfo.setState(1);

        result = this.customerInfoMapper.insertSelective(customerInfo);
        if (result < 1) throw new RuntimeException("添加customerInfo失败");
        result = this.customerCompanyInfoMapper.insertSelective(customerCompanyInfo);
        if (result < 1) throw new RuntimeException("添加customerCompanyInfo失败");

        return result;
    }

    @Override
    public int modifyCompany(CustomerInfo customerInfo, CustomerCompanyInfo customerCompanyInfo) {
        int result = 0;
        result = this.customerInfoMapper.updateByPrimaryKeySelective(customerInfo);
        if (result < 0) throw new RuntimeException("更新customerInfo失败");
        result = this.customerCompanyInfoMapper.updateByPrimaryKeySelective(customerCompanyInfo);
        if (result < 0) throw new RuntimeException("更新customerCompanyInfo失败");
        return result;
    }

    @Override
    public int removeCompany(CustomerInfo customerInfo, CustomerCompanyInfo customerCompanyInfo) {
        int result = 0;
        customerInfo.setState(0);
        result = this.customerInfoMapper.updateByPrimaryKeySelective(customerInfo);
        if (result < 1) throw new RuntimeException("软删除customerInfo失败");
        customerCompanyInfo.setState(0);
        result = this.customerCompanyInfoMapper.updateByPrimaryKeySelective(customerCompanyInfo);
        if (result < 1) throw new RuntimeException("软删除customerCompanyInfo失败");
        return result;
    }

    @Override
    public int delByPrimaryKey(String guid) {
        return 0;
    }

    @Override
    public int save(CustomerCompanyInfoService record) {
        return 0;
    }

    @Override
    public int saveSelective(CustomerCompanyInfoService record) {
        return 0;
    }

    @Override
    public CustomerCompanyInfoService queryByPrimaryKey(String guid) {
        return null;
    }

    @Override
    public int modifyByPrimaryKeySelective(CustomerCompanyInfoService record) {
        return 0;
    }

    @Override
    public int modifyByPrimaryKeyWithBLOBs(CustomerCompanyInfoService record) {
        return 0;
    }

    @Override
    public int modifyByPrimaryKey(CustomerCompanyInfoService record) {
        return 0;
    }
}
