package com.hcloud.microserver.bank.service.impl;

import com.hcloud.microserver.facade.carbon.entity.DayCarbonBO;
import com.hcloud.microserver.bank.dao.WebIndexMapper;
import com.hcloud.microserver.bank.service.WebIndexService;
import com.hcloud.microserver.facade.carbon.entity.GroupNumBO;
import com.hcloud.microserver.facade.carbon.entity.UserBuyBO;
import com.hcloud.microserver.facade.carbon.forms.DayCarbonFrom;
import com.hcloud.microserver.facade.carbon.forms.GroupNumFrom;
import com.hcloud.microserver.facade.carbon.forms.UserBuyFrom;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

@Service
public class WebIndexServiceImpl implements WebIndexService {
    @Autowired
    private WebIndexMapper webIndexMapper;

    @Override
    public DayCarbonBO dayCarbon(DayCarbonFrom dayCarbonFrom) {
        return webIndexMapper.dayCarbon(dayCarbonFrom);
    }

    @Override
    public List<UserBuyBO> userBuy(UserBuyFrom userBuyFrom) {
        return webIndexMapper.userBuy(userBuyFrom);
    }

    @Override
    public List<GroupNumBO> GroupNum(GroupNumFrom userBuyFrom) {
        Map<String, GroupNumBO> groupNumBOS = webIndexMapper.GroupNum(userBuyFrom);
        List<GroupNumBO> list = new ArrayList<>();
        for (int i = 1; i <= 12; i++) {

            GroupNumBO groupNumBOnew = new GroupNumBO();
            BigDecimal bigDecimal = new BigDecimal(0);
            String num = i + "";
            groupNumBOnew.setNum(num);
            groupNumBOnew.setCarbonNum(bigDecimal);
            groupNumBOnew.setMoneyNum(bigDecimal);
            GroupNumBO groupNumBO = groupNumBOS.get(num);
            if (!StringUtils.isEmpty(groupNumBO)) {
                list.add(groupNumBO);
            } else {
                list.add(groupNumBOnew);
            }
        }
        return list;
    }
}
