package com.hcloud.microserver.sys.facade.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.sys.facade.fallback.impl.SysDeptManagerFallback;
import com.hcloud.microserver.sys.facade.forms.SysDeptForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @author xiezt
 */
@FeignClient(name = "system-service", path = "/dept",fallbackFactory = SysDeptManagerFallback.class)
public interface SysDepartmentClient {
    /**
     * 查询部门信息
     * @param sysDeptForm
     * @return
     */
    @PostMapping("/listByPage")
    ResultVO queryDeptInfoByPage(@RequestBody SysDeptForm sysDeptForm);

    /**
     * 新增部门信息
     * @param sysDeptForm
     * @return
     */
    @PostMapping("/saveDept")
    ResultVO saveDeptInfo(@RequestBody SysDeptForm sysDeptForm);

    /**
     * 删除部门信息
     * @param sysDeptForm
     * @return
     */
    @GetMapping("/delDept")
    ResultVO delDeptInfo(@RequestBody SysDeptForm sysDeptForm);

    /**
     * 更新部门信息
     * @param sysDeptForm
     * @return
     */
    @PostMapping("/modifyDept")
    ResultVO updateDeptInfo(@RequestBody SysDeptForm sysDeptForm);
}
