package com.hcloud.microserver.sys.facade.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.sys.facade.entity.SysPermission;
import com.hcloud.microserver.sys.facade.fallback.impl.SysPermissionManagerFallback;
import com.hcloud.microserver.sys.facade.forms.SysPermissionForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

@FeignClient(name = "system-service", path = "/permission", fallbackFactory = SysPermissionManagerFallback.class)
public interface SysPermissionClient {

    @PostMapping("/permissionList")
    ResultVO permissionList(@RequestBody SysPermissionForm sysPermissionForm);

    @PostMapping("/list")
    ResultVO list(@RequestBody SysPermission sysPermission);
}
