package com.hcloud.microserver.sys.facade.client;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.sys.facade.fallback.impl.SysRoleManagerFallback;
import com.hcloud.microserver.sys.facade.forms.SysRoleForm;
import org.springframework.cloud.netflix.feign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @author xiezt
 */
@FeignClient(name = "system-service", path = "/role",fallbackFactory = SysRoleManagerFallback.class)
public interface SysRoleClient {

    /**
     * 查询角色信息
     * @param sysRoleForm
     * @return
     */
    @PostMapping("/roleList")
    ResultVO querySysRoleInfo(@RequestBody SysRoleForm sysRoleForm);

    /**
     * 查询角色基本权限信息
     * @param sysRoleForm
     * @return
     */
    @GetMapping("/permissionTree")
    ResultVO queryRolePermissionById(@RequestBody SysRoleForm sysRoleForm);

    /**
     * 新增角色基本信息
     * @param sysRoleForm
     * @return
     */
    @PostMapping("/saveInfo")
    ResultVO saveRoleInfo(@RequestBody SysRoleForm sysRoleForm);

    /**
     * 更新角色基本信息
     * @param sysRoleForm
     * @return
     */
    @PostMapping("/updateInfo")
    ResultVO updateRoleInfo(@RequestBody SysRoleForm sysRoleForm);

    /**
     * 更新角色权限信息
     * @param sysRoleForm
     * @return
     */
    @PostMapping("/updatePermissionInfo")
    ResultVO updateRolePermissionInfo(@RequestBody SysRoleForm sysRoleForm);

    /**
     * 删除角色基本信息
     * @param sysRoleForm
     * @return
     */
    @GetMapping("/delRoleInfo")
    ResultVO delRolePermissionInfo(@RequestBody SysRoleForm sysRoleForm);
}
