package com.hcloud.microserver.sys.facade.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.sys.facade.fallback.BaseDictionaryManagerFactory;
import com.hcloud.microserver.sys.facade.forms.BaseDictionaryForm;
import feign.hystrix.FallbackFactory;
import org.springframework.stereotype.Component;

@Component
public class BaseDictionaryFallback implements FallbackFactory<BaseDictionaryManagerFactory> {

    @Override
    public BaseDictionaryManagerFactory create(Throwable cause) {
        return new BaseDictionaryManagerFactory() {
            @Override
            public ResultVO findByEntity(BaseDictionaryForm baseDictionaryForm) {
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
