package com.hcloud.microserver.sys.facade.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.sys.facade.fallback.SysDeptManagerFactory;
import com.hcloud.microserver.sys.facade.forms.SysDeptForm;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

/**
 * @author xiezt
 */
@Slf4j
@Component
public class SysDeptManagerFallback implements FallbackFactory<SysDeptManagerFactory> {

    @Override
    public SysDeptManagerFactory create(Throwable cause) {
        return new SysDeptManagerFactory(){
            /**
             * 查询部门信息
             * @param sysDeptForm
             * @return
             */
            @Override
            public ResultVO queryDeptInfoByPage(SysDeptForm sysDeptForm) {
                log.info("error method=======================>queryDeptInfoByPage");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 新增部门信息
             * @param sysDeptForm
             * @return
             */
            @Override
            public ResultVO saveDeptInfo(SysDeptForm sysDeptForm) {
                log.info("error method=======================>saveDeptInfo");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 删除部门信息
             * @param sysDeptForm
             * @return
             */
            @Override
            public ResultVO delDeptInfo(SysDeptForm sysDeptForm) {
                log.info("error method=======================>delDeptInfo");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            /**
             * 更新部门信息
             * @param sysDeptForm
             * @return
             */
            @Override
            public ResultVO updateDeptInfo(SysDeptForm sysDeptForm) {
                log.info("error method=======================>updateDeptInfo");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
