package com.hcloud.microserver.sys.facade.fallback.impl;

import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.sys.facade.entity.SysPermission;
import com.hcloud.microserver.sys.facade.fallback.SysPermissionManagerFactory;
import com.hcloud.microserver.sys.facade.forms.SysPermissionForm;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

@Slf4j
@Component
public class SysPermissionManagerFallback implements FallbackFactory<SysPermissionManagerFactory> {
    @Override
    public SysPermissionManagerFactory create(Throwable cause) {
        return new SysPermissionManagerFactory() {
            @Override
            public ResultVO permissionList(SysPermissionForm sysPermissionForm) {
                log.error("查询权限列表被熔断 permissionList");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }

            @Override
            public ResultVO list(SysPermission sysPermission) {
                log.error("查询权限列表被熔断 /list");
                return new ResultVO(ResultEnum.SYS_BREAK_ERROR);
            }
        };
    }
}
