package com.hcloud.microserver.sys.facade.vo;

import lombok.Data;

import java.io.Serializable;
import java.util.List;

@Data
public class SysTreeNode implements Serializable {

    /**
     * 当前权限ID
     */
    private String id;
    /**
     * 当前权限父ID
     */
    private String pId;
    /**
     * 当前权限名称
     */
    private String name;
    /**
     * 菜单编码
     */
    private String ccode;
    /**
     * 当前权限状态：false未授权，true已授权
     */
    private boolean checked = false;
    /**
     * 状态   0：失效    1：未启用      2：启用
     */
    private String cstatus;
    /**
     * 描述
     */
    private String description;
    /**
     * 图标
     */
    private String icon;
    /**
     * 是否为目录（是否可展开）
     */
    private Integer isMenu;
    /**
     * 是否可删除
     */
    private Integer canDel;
    /**
     * 指向菜单的URL
     */
    private String targetMenuGuid;
    /**
     * 当前权限的子权限集合
     */
    private List<SysTreeNode> children = null;
}
