package com.hcloud.microserver.sys.service;

import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.feign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;
import org.springframework.transaction.annotation.EnableTransactionManagement;

/**
 * @author xiezt
 */
@EnableDiscoveryClient
@SpringBootApplication
@EnableFeignClients(basePackages = {"com.hcloud.microserver"})
@EnableTransactionManagement
@ComponentScan(basePackages = "com.hcloud")
@MapperScan(basePackages = {"com.hcloud.microserver.sys.service.dao"})
public class SysManagerServiceApplication {
    public static void main(String[] args) {
        SpringApplication.run(SysManagerServiceApplication.class, args);
    }
}
