package com.hcloud.microserver.sys.service.controller;

import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.util.BeanCopyUtil;
import com.hcloud.microserver.sys.facade.client.BaseDictionaryClient;
import com.hcloud.microserver.sys.facade.entity.BaseDictionary;
import com.hcloud.microserver.sys.facade.forms.BaseDictionaryForm;
import com.hcloud.microserver.sys.service.service.BaseDictionaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping("/dic")
public class BaseDictionaryManageController extends BaseController implements BaseDictionaryClient {

    @Autowired
    private BaseDictionaryService baseDictionaryService;

    @Override
    @PostMapping("/findByEntity")
    public ResultVO findByEntity(@RequestBody BaseDictionaryForm baseDictionaryForm) {
        BaseDictionary baseDictionary = BeanCopyUtil.convertBean(baseDictionaryForm, BaseDictionary.class);
        List<BaseDictionary> baseDictionaries = this.baseDictionaryService.findByEntity(baseDictionary);
        return success(baseDictionaries);
    }
}
