package com.hcloud.microserver.sys.service.controller;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.sys.facade.client.SysDepartmentClient;
import com.hcloud.microserver.sys.facade.forms.SysDeptForm;
import com.hcloud.microserver.sys.service.service.SysDepartmentService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/dept")
@Slf4j
public class SysManagerDeptController extends BaseController implements SysDepartmentClient {

    @Autowired
    private SysDepartmentService sysDepartmentService;

    @PostMapping("/listByPage")
    @Override
    public ResultVO queryDeptInfoByPage(@RequestBody SysDeptForm sysDeptForm) {
        PageInfo<Page<Map>> pageInfo = sysDepartmentService.queryDeptInfoListByPage(sysDeptForm);
        if (null != pageInfo) {
            return success(pageInfo.getList());
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @PostMapping("/saveDept")
    @Override
    public ResultVO saveDeptInfo(@RequestBody SysDeptForm sysDeptForm) {
        int success = sysDepartmentService.saveDeptmentInfo(sysDeptForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }


    @PostMapping("/delDept")
    @Override
    public ResultVO delDeptInfo(@RequestBody SysDeptForm sysDeptForm) {
        int success = sysDepartmentService.delByPrimaryKey(sysDeptForm.getGuid());
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }


    @PostMapping("/modifyDept")
    @Override
    public ResultVO updateDeptInfo(@RequestBody SysDeptForm sysDeptForm) {
        int success = sysDepartmentService.updateDepartmentInfo(sysDeptForm);
        if (success > 0) {
            return success();
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }
}
