package com.hcloud.microserver.sys.service.controller;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.sys.facade.entity.SysPermission;
import com.hcloud.microserver.sys.facade.forms.SysPermissionForm;
import com.hcloud.microserver.sys.service.service.SysPermissionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;
import java.util.Objects;

@Slf4j
@RestController
@RequestMapping(value = "/permission")
public class SysManagerPermissionController extends BaseController {

    @Autowired
    private SysPermissionService sysPermissionService;

    @PostMapping("/permissionList")
    public ResultVO permissionList(@RequestBody SysPermissionForm sysPermissionForm) {
        PageInfo<Page<Map>> pageInfo = sysPermissionService.queryPermissionListByPage(sysPermissionForm);
        if (!Objects.isNull(pageInfo)) {
            return success(pageInfo.getList(), pageInfo.getTotal());
        }
        return new ResultVO(ResultEnum.SYS_ERROR);
    }

    @PostMapping("/list")
    public ResultVO list(@RequestBody SysPermission sysPermission) {
        log.info("参数=====================>{}", sysPermission);
        List<SysPermission> list = this.sysPermissionService.queryByCondition(sysPermission);
        if (Objects.nonNull(list))
            return success(list);
        return new ResultVO(ResultEnum.SYS_ERROR);
    }
}
