package com.hcloud.microserver.sys.service.service;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.sys.facade.entity.SysDepartment;
import com.hcloud.microserver.sys.facade.forms.SysDeptForm;

import java.util.List;
import java.util.Map;

/**
 * Created by apple on 2018/9/7.
 */
public interface SysDepartmentService extends BaseServie<SysDepartment, String> {
    /**
     * 获取所有部门信息
     *
     * @return
     */
    List<Map<String, String>> queryAllDepartment();

    /**
     * 分页查询部门信息
     *
     * @param sysDeptForm
     * @return
     */
    PageInfo<Page<Map>> queryDeptInfoListByPage(SysDeptForm sysDeptForm);

    /**
     * 保存部门信息
     *
     * @param sysDeptForm
     * @return
     */
    int saveDeptmentInfo(SysDeptForm sysDeptForm);

    /**
     * 更新部门信息
     *
     * @param sysDeptForm
     * @return
     */
    int updateDepartmentInfo(SysDeptForm sysDeptForm);

}
