package com.hcloud.microserver.sys.service.service;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.sys.facade.entity.SysPermission;
import com.hcloud.microserver.sys.facade.forms.SysPermissionForm;
import com.hcloud.microserver.sys.facade.vo.SysTreeNode;

import java.util.List;
import java.util.Map;

/**
 * @author apple
 * @date 2018/9/7
 */
public interface SysPermissionService extends BaseServie<SysPermission, String> {
    /**
     * 获取权限树
     *
     * @param guid
     * @param states
     * @return
     */
    List<SysTreeNode> selectPermTree(String guid, String states);

    /**
     * 权限列表
     *
     * @param
     * @return
     */
    PageInfo<Page<Map>> queryPermissionListByPage(SysPermissionForm sysPermissionForm);

    /**
     * 权限列表不分页
     * @param sysPermissionForm
     * @return
     */
    List<SysPermission> queryByCondition(SysPermission sysPermission);
}
