package com.hcloud.microserver.sys.service.service;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.commoncore.base.PageBean;
import com.hcloud.microserver.sys.facade.entity.SysRole;
import com.hcloud.microserver.sys.facade.forms.SysRoleForm;

import java.util.List;
import java.util.Map;

/**
 *
 * @author apple
 * @date 2018/9/7
 */
public interface SysRoleService extends BaseServie<SysRole, String> {
    /**
     * 获取角色信息
     * @return
     */
    List<Map<String, String>> queryAllRole();

    /**
     * 分页查询角色信息
     *
     * @param sysRoleForm
     * @return
     */
    PageInfo<Page<Map>> queryRoleListByPage(SysRoleForm sysRoleForm);

    /**
     * 删除角色权限信息
     *
     * @param roleId
     * @return
     */
    int delRoleInfoAndPermission(String roleId);

    /**
     * 保存角色信息
     *
     * @param sysRoleForm
     * @return
     */
    int saveRoleInfo(SysRoleForm sysRoleForm);

    /**
     * 获取最大编号
     *
     * @return
     */
    String getMaxCode();

}
