package com.hcloud.microserver.sys.service.service;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageInfo;
import com.hcloud.microserver.commoncore.base.BaseServie;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.sys.facade.entity.SysUser;
import com.hcloud.microserver.sys.facade.forms.SysMangerForm;
import com.hcloud.microserver.sys.facade.forms.SysUserForm;

import java.util.Map;

/**
 *
 * @author xiezt
 * @date 2018/9/7
 */
public interface SysUserService extends BaseServie<SysUser, String> {

    /**
     * 获取系统用户信息，通过登录信息
     *
     * @param loginName
     * @param password
     * @return
     */
    SysUser getSystemByUser(String loginName, String password);

    /**
     * 分页查询用户信息
     *
     * @param sysMangerForm
     * @return
     */
    PageInfo<Page<Map>> queryUserInfoByPage(SysMangerForm sysMangerForm);

    /**
     * 保存用户及权限
     *
     * @param sysUserForm
     * @return
     */
    ResultVO saveUserInfoAndPermission(SysUserForm sysUserForm);


    /**
     * 更新用户信息及权限
     *
     * @param sysUserForm
     * @return
     */
    ResultVO modifyUserInfoAndPermission(SysUserForm sysUserForm);

    /**
     * 更新用户权限
     *
     * @param sysUserForm
     * @return
     */
    int updateUserPermission(SysUserForm sysUserForm);


}
