package com.hcloud.microserver.sys.service.service.impl;

import com.hcloud.microserver.commoncore.util.GetUUID;
import com.hcloud.microserver.sys.facade.forms.SysRoleForm;
import com.hcloud.microserver.sys.service.dao.SysRolePermissionMapper;
import com.hcloud.microserver.sys.facade.entity.SysRolePermission;
import com.hcloud.microserver.sys.service.service.SysRolePermissionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author xiezt
 * @date 2018/9/7
 */

@Service("sysRolePermissionService")
@Slf4j
public class SysRolePermissionServiceImpl implements SysRolePermissionService {

    @Resource
    private SysRolePermissionMapper sysRolePermissionMapper;

    @Override
    public int delByPrimaryKey(String guid) {
        return sysRolePermissionMapper.deleteByPrimaryKey(guid);
    }

    @Override
    public int save(SysRolePermission record) {
        return sysRolePermissionMapper.insert(record);
    }

    @Override
    public int saveSelective(SysRolePermission record) {
        return sysRolePermissionMapper.insertSelective(record);
    }

    @Override
    public SysRolePermission queryByPrimaryKey(String guid) {
        return sysRolePermissionMapper.selectByPrimaryKey(guid);
    }

    @Override
    public int modifyByPrimaryKeySelective(SysRolePermission record) {
        return sysRolePermissionMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int modifyByPrimaryKeyWithBLOBs(SysRolePermission record) {
        return sysRolePermissionMapper.updateByPrimaryKeyWithBLOBs(record);
    }

    @Override
    public int modifyByPrimaryKey(SysRolePermission record) {
        return sysRolePermissionMapper.updateByPrimaryKey(record);
    }

    @Override
    public List<String> selectPermByRoleId(String roleId) {
        return sysRolePermissionMapper.selectPermByRoleId(roleId);
    }

    @Override
    public int delPermByRoleId(String roleId) {
        return sysRolePermissionMapper.delPermByRoleId(roleId);
    }

    @Override
    public int updateRolePermissionByPermisList(SysRoleForm sysRoleForm) {
        log.info("sysRoleForm====================>{}", sysRoleForm);
        if (null != sysRoleForm) {
            String roleId = sysRoleForm.getRoleId();
            String[] permIds = sysRoleForm.getPermIds();
            //删除老的权限列表
            sysRolePermissionMapper.delPermByRoleId(roleId);
            List<SysRolePermission> list = new ArrayList<>();
            if (null != permIds && permIds.length > 0) {
                for (int i = 0, len = permIds.length; i < len; i++) {
                    SysRolePermission sysRolePermission = new SysRolePermission();
                    sysRolePermission.setGuid(GetUUID.getUUID());
                    sysRolePermission.setRefSysRole(roleId);
                    sysRolePermission.setRefSysPermission(permIds[i]);
                    list.add(sysRolePermission);
                }
            }
            return sysRolePermissionMapper.updateRolePermissionByPermisList(list);
        }
        return 0;
    }
}
