package com.hcloud.microserver.sys.service.service.impl;

import com.hcloud.microserver.commoncore.util.GetUUID;
import com.hcloud.microserver.sys.service.dao.SysUserPermissionMapper;
import com.hcloud.microserver.sys.facade.entity.SysUserPermission;
import com.hcloud.microserver.sys.service.service.SysUserPermissionService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

/**
 *
 * @author apple
 * @date 2018/9/8
 */
@Slf4j
@Service("sysUserPermissionService")
public class SysUserPermissionServiceImpl implements SysUserPermissionService {

    @Resource
    private SysUserPermissionMapper sysUserPermissionMapper;

    @Override
    public int delByPrimaryKey(String guid) {
        return sysUserPermissionMapper.deleteByPrimaryKey(guid);
    }

    @Override
    public int save(SysUserPermission record) {
        return sysUserPermissionMapper.insert(record);
    }

    @Override
    public int saveSelective(SysUserPermission record) {
        return sysUserPermissionMapper.insertSelective(record);
    }

    @Override
    public SysUserPermission queryByPrimaryKey(String guid) {
        return sysUserPermissionMapper.selectByPrimaryKey(guid);
    }

    @Override
    public int modifyByPrimaryKeySelective(SysUserPermission record) {
        return sysUserPermissionMapper.updateByPrimaryKeySelective(record);
    }

    @Override
    public int modifyByPrimaryKeyWithBLOBs(SysUserPermission record) {
        return sysUserPermissionMapper.updateByPrimaryKeyWithBLOBs(record);
    }

    @Override
    public int modifyByPrimaryKey(SysUserPermission record) {
        return sysUserPermissionMapper.updateByPrimaryKey(record);
    }

    @Override
    public List<Map<String, Object>> getUserPermissionById(String id) {
        log.info("userid================>{}", id);
        if (null != id && !"".equals(id)) {
            return sysUserPermissionMapper.getUserPermissionById(id);
        }
        return null;
    }

    /**
     * 添加用户权限
     *
     * @param uid
     * @param permission
     * @return
     */
    @Override
    public int insertBatchPermissionByUid(String uid, List<String> permission) {
        List<SysUserPermission> batchList = Collections.emptyList();
        int success = 0;
        if (null != permission && permission.size() > 0 && null != uid) {
            batchList = new ArrayList<>();
            sysUserPermissionMapper.delUserPermissionByUid(uid);
            for (String s : permission) {
                SysUserPermission bean = new SysUserPermission();
                bean.setGuid(GetUUID.getUUID());
                bean.setRefSysUser(uid);
                bean.setRefSysPermission(s);
                batchList.add(bean);
            }
            success = sysUserPermissionMapper.insertBatchPermissionByUid(batchList);
        }
        return success;
    }

    /**
     * 删除用户权限
     *
     * @param uid
     * @return
     */
    @Override
    public int delUserPermissionByUid(String uid) {
        return sysUserPermissionMapper.delUserPermissionByUid(uid);
    }
}
