package com.hcloud.microserver.bank;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.autoconfigure.jdbc.DataSourceAutoConfiguration;
import org.springframework.cloud.client.discovery.EnableDiscoveryClient;
import org.springframework.cloud.netflix.feign.EnableFeignClients;
import org.springframework.context.annotation.ComponentScan;

@EnableDiscoveryClient
@EnableFeignClients("com.hcloud.microserver")
@SpringBootApplication(scanBasePackages = "com.hcloud")
@ComponentScan(basePackages = "com.hcloud")
@EnableAutoConfiguration(exclude={DataSourceAutoConfiguration.class})
public class CarbonWebApplication {

    public static void main(String[] args) {
        SpringApplication.run(CarbonWebApplication.class, args);
    }

}
