package com.hcloud.microserver.bank.common;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.commoncore.base.BaseController;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.commoncore.constant.GlobleConstant;
import com.hcloud.microserver.commoncore.domain.FileDO;
import com.hcloud.microserver.commoncore.enums.ResultEnum;
import com.hcloud.microserver.commoncore.service.RedisUtils;
import com.hcloud.microserver.commoncore.util.BeanCopyUtil;
import com.hcloud.microserver.commoncore.util.FileType;
import com.hcloud.microserver.commoncore.util.FileUtil;
import com.hcloud.microserver.facade.carbon.forms.CustomerInfoForm;
import lombok.extern.slf4j.Slf4j;
import me.chanjar.weixin.mp.bean.result.WxMpUser;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;

import java.util.Date;
import java.util.Map;
import java.util.Objects;

/**
 * @author xiezt
 */
@Slf4j
@Component
public class CarbonBaseController extends BaseController {

    private static final String WECHAT_USER_INFO="wechatUserInfo";

    @Value("${img.location}")
    private String UPLOAD_FILE_PATH;


    @Autowired
    private RedisUtils redisUtils;

    protected String getUserId(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        log.info(JSONObject.toJSONString(redisMap));
        if(null!=redisMap ){
            return (String) redisMap.get(GlobleConstant.USER_GUID);
        }
        return null;
    }

    protected String getWechatUserInfoId(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        log.info(JSONObject.toJSONString(redisMap));
        if (redisMap.containsKey("wechatUserInfo"))
        if(null!=redisMap ){
            return (String) redisMap.get(GlobleConstant.USER_GUID);
        }
        return null;
    }


    protected Map getLoginInfo(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(null!=redisMap ){
            return redisMap;
        }
        return null;
    }

    protected BaseInfoDO initiSaveObject(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        if(accessToke==null || "".equals(accessToke)){return null;}
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(null!=redisMap){
            CustomerInfoForm customerInfoForm = (CustomerInfoForm) redisMap.get(WECHAT_USER_INFO);
            BaseInfoDO baseInfoDO = BeanCopyUtil.convertBean(customerInfoForm,BaseInfoDO.class);
            baseInfoDO.setCustomerId(customerInfoForm.getGuid());
            baseInfoDO.setState(1);
            baseInfoDO.setCreateTime(new Date());
            baseInfoDO.setModifiedTime(new Date());
            return baseInfoDO;
        }
        return null;
    }

    protected BaseInfoDO initiSaveObject(String token){
        if(token==null || "".equals(token)){return null;}
        Map redisMap = (Map) redisUtils.getValue(token);
        if(null!=redisMap){
            CustomerInfoForm customerInfoForm = (CustomerInfoForm) redisMap.get(WECHAT_USER_INFO);
            BaseInfoDO baseInfoDO = BeanCopyUtil.convertBean(customerInfoForm,BaseInfoDO.class);
            baseInfoDO.setCustomerId(customerInfoForm.getGuid());
            baseInfoDO.setState(1);
            baseInfoDO.setCreateTime(new Date());
            baseInfoDO.setModifiedTime(new Date());
            return baseInfoDO;
        }
        return null;
    }

    protected WxMpUser initiWwChatInfo(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        if(accessToke==null || "".equals(accessToke)){return null;}
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(Objects.nonNull(redisMap)){
            WxMpUser wxMpUser = (WxMpUser) redisMap.get(GlobleConstant.WECHAT_INFO_PREFIX);
            if(Objects.nonNull(wxMpUser)){
                return wxMpUser;
            }
        }
        return null;
    }

    protected WxMpUser initiHWwChatInfo(){
        String accessToke = this.getRequestObject().getHeader(ACCESS_TOKEN);
        if(accessToke==null || "".equals(accessToke)){return null;}
        Map redisMap = (Map) redisUtils.getValue(accessToke);
        if(Objects.nonNull(redisMap)){
            WxMpUser wxMpUser = (WxMpUser) redisMap.get(GlobleConstant.WECHAT_INFO_PREFIX);
            if(Objects.nonNull(wxMpUser)){
                return wxMpUser;
            }
        }
        return null;
    }

    /**
     * 上传代码
     * @param file
     * @return
     */
    public ResultVO uploadImageFiles(@RequestParam("file") MultipartFile file, String type){
        String fileName = file.getOriginalFilename();
        fileName = FileUtil.renameToUUID(fileName);
        FileDO sysFile = new FileDO(FileType.fileType(fileName),fileName, new Date());
        try {
            String targetPath = UPLOAD_FILE_PATH;
            if(null!=type && !"".equals(type)){
                sysFile.setUrl(type+sysFile.getUrl());
                targetPath=UPLOAD_FILE_PATH+type;
            }
            FileUtil.uploadFile(file.getBytes(),targetPath , fileName);
        } catch (Exception e) {
            return new ResultVO(ResultEnum.SYS_ERROR);
        }
        return success(sysFile.getUrl());
    }

}
