package com.hcloud.microserver.bank.web;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.BasePositionClient;
import com.hcloud.microserver.facade.carbon.entity.BasePosition;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@Slf4j
@RestController
@RequestMapping("/web/position")
@Api(description = "基本区域信息管理服务")
public class BasePositionController extends CarbonBaseController {

    @Autowired
    private BasePositionClient basePositionClient;

    @PostMapping("/findByCodeAndLevel")
    public ResponseBase findByCodeAndLevel(@RequestBody BasePosition basePosition) {
        ResultVO resultVO = this.basePositionClient.findByCodeAndLevel(basePosition);
        return responseSuccess(resultVO);
    }

    @PostMapping("/findByCodes")
    private ResponseBase findByCodes(@RequestBody JSONObject parameters) {
        log.info("看看参数: {}", parameters);
        JSONArray codesArray = parameters.getJSONArray("codes");
        List<String> codes = codesArray.toJavaList(String.class);
        log.info("能不能转换: {}", codes);
        ResultVO resultVO = this.basePositionClient.findByCodes(codes);
        return responseSuccess(resultVO);
    }

    @PostMapping("/findChongqingArea")
    private ResponseBase findChongqingArea(@RequestBody(required = false) BasePosition basePosition) {
        ResultVO resultVO = this.basePositionClient.findChongqingArea(basePosition);
        return responseSuccess(resultVO);
    }
}
