package com.hcloud.microserver.bank.web;

import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.CollectiveFarmerClient;
import com.hcloud.microserver.facade.carbon.forms.CollectiveFarmerForm;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/web/collectiveFarmer")
@Api(description = "集体农户信息管理服务")
public class CollectiveFarmerController extends CarbonBaseController {

    @Autowired
    private CollectiveFarmerClient collectiveFarmerClient;

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        ResultVO resultVO = this.collectiveFarmerClient.searchByPage(collectiveFarmerForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/save")
    public ResponseBase save(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        collectiveFarmerForm.setCreateUser(this.getUserId());
        collectiveFarmerForm.setModifiedUser(this.getUserId());
        ResultVO resultVO = this.collectiveFarmerClient.save(collectiveFarmerForm);
        if (resultVO.getCode() == 0) {
            return responseSuccess(resultVO);
        }
        return responseError(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase update(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        ResultVO resultVO = this.collectiveFarmerClient.update(collectiveFarmerForm);
        if (resultVO.getCode() == 0)
            return responseSuccess(resultVO);
        return responseError(resultVO);
    }

    @PostMapping("/delete")
    public ResponseBase del(@RequestBody CollectiveFarmerForm collectiveFarmerForm) {
        ResultVO resultVO = this.collectiveFarmerClient.delete(collectiveFarmerForm);
        if (resultVO.getCode() == 0)
            return responseSuccess(resultVO);
        return responseError(resultVO);
    }
}
