package com.hcloud.microserver.bank.web;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.CompanyClient;
import com.hcloud.microserver.facade.carbon.client.CustomerClient;
import com.hcloud.microserver.facade.carbon.forms.CustomerCompanyInfoForm;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/web/company")
@Api(description = "企业信息管理服务")
public class CompanyController extends CarbonBaseController {

    @Autowired
    private CustomerClient customerClient;

    @Autowired
    private CompanyClient companyClient;

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody CustomerCompanyInfoForm customerCompanyInfoForm) {
        ResultVO resultVO = this.customerClient.searchCompanyByPage(customerCompanyInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/add")
    public ResponseBase addCompany(@RequestBody JSONObject jsonObject) {
        ResultVO resultVO = this.companyClient.addCompany(jsonObject);
        return responseSuccess(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase updateCompany(@RequestBody JSONObject jsonObject) {
        ResultVO resultVO = this.companyClient.updateCompany(jsonObject);
        return responseSuccess(resultVO);
    }

    @PostMapping("/delete")
    public ResponseBase deleteCompany(@RequestBody JSONObject jsonObject) {
        ResultVO resultVO = this.companyClient.deleteCompany(jsonObject);
        return responseSuccess(resultVO);
    }
}
