package com.hcloud.microserver.bank.web;

import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.CustomerClient;
import com.hcloud.microserver.facade.carbon.forms.CustomerInfoForm;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author JYJ
 */
@RestController
@RequestMapping("/web/customer")
@Api(description = "管理端客户服务")
public class CustomerInfoController extends CarbonBaseController {

    @Autowired
    private CustomerClient customerClient;

    /**
     * 分页查询爱心用户信息
     *
     * @param customerInfoForm
     * @return
     */
    @PostMapping("/searchByPage")
    public ResponseBase searchCustomerInfoByPage(@RequestBody CustomerInfoForm customerInfoForm) {
        ResultVO resultVO = this.customerClient.searchCustomerInfoByPage(customerInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/resetPassword")
    public ResponseBase resetPassword(@RequestBody CustomerInfoForm customerInfoForm) {
        ResultVO resultVO = this.customerClient.resetPassword(customerInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase update(@RequestBody CustomerInfoForm customerInfoForm) {
        ResultVO resultVO = this.customerClient.modifiedCustomerInfo(customerInfoForm);
        return responseSuccess(resultVO);
    }
}
