package com.hcloud.microserver.bank.web;

import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.FarmerInfoClient;
import com.hcloud.microserver.facade.carbon.forms.FarmerInfoForm;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/web/farmer")
@Api(description = "农户信息管理服务")
public class FarmerInfoController extends CarbonBaseController {

    @Autowired
    private FarmerInfoClient farmerInfoClient;

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody FarmerInfoForm farmerInfoForm) {
        ResultVO resultVO = this.farmerInfoClient.searchByPage(farmerInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/save")
    public ResponseBase save(@RequestBody FarmerInfoForm farmerInfoForm) {
        ResultVO resultVO = this.farmerInfoClient.save(farmerInfoForm);
        if (resultVO.getCode() == 0) {
            return responseSuccess(resultVO);
        }
        return responseError(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase update(@RequestBody FarmerInfoForm farmerInfoForm) {
        ResultVO resultVO = this.farmerInfoClient.update(farmerInfoForm);
        if (resultVO.getCode() == 0)
            return responseSuccess(resultVO);
        return responseError(resultVO);
    }

    @PostMapping("/delete")
    public ResponseBase del(@RequestBody FarmerInfoForm farmerInfoForm) {
        ResultVO resultVO = this.farmerInfoClient.delete(farmerInfoForm);
        if (resultVO.getCode() == 0)
            return responseSuccess(resultVO);
        return responseError(resultVO);
    }

    @PostMapping("/searchByCollectiveId")
    public ResponseBase findByCollectiveId(@RequestParam(name = "collectiveId") String collectiveId) {
        ResultVO resultVO = this.farmerInfoClient.searchByCollectiveId(collectiveId);
        return responseSuccess(resultVO);
    }

    @PostMapping("/searchByProductGuid")
    public ResponseBase searchByProductGuid(@RequestParam(name = "productGuid") String productGuid) {
        ResultVO resultVO = this.farmerInfoClient.searchByProductGuid(productGuid);
        return responseSuccess(resultVO);
    }

}
