package com.hcloud.microserver.bank.web;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.GoodsInfoClient;
import com.hcloud.microserver.facade.carbon.forms.GoodsInfoForm;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/web/goods")
@Api(description = "商品信息管理服务")
public class GoodsInfoController extends CarbonBaseController {

    @Autowired
    private GoodsInfoClient goodsInfoClient;

    @PostMapping("/shelves")
    public ResponseBase shelves(@RequestBody List<GoodsInfoForm> goodsInfoForms) {
        ResultVO resultVO = this.goodsInfoClient.shelves(goodsInfoForms);
        return responseSuccess(resultVO);
    }

    @PostMapping("/delete")
    public ResponseBase delete(@RequestBody GoodsInfoForm goodsInfoForm) {
        ResultVO resultVO = this.goodsInfoClient.delete(goodsInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase update(@RequestBody GoodsInfoForm goodsInfoForm) {
        ResultVO resultVO = this.goodsInfoClient.update(goodsInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody GoodsInfoForm goodsInfoForm) {
        ResultVO resultVO = this.goodsInfoClient.searchByPage(goodsInfoForm);
        if (resultVO.getCode() == 0) {
            return responseSuccess(resultVO);
        }
        return responseError(resultVO);
    }

    @PostMapping("/searchJoinListByPage")
    public ResponseBase searchJoinListByPage(@RequestBody GoodsInfoForm goodsInfoForm) {
        ResultVO resultVO = this.goodsInfoClient.searchJoinListByPage(goodsInfoForm);
        if (resultVO.getCode() == 0){ return responseSuccess(resultVO);}
        return responseError(resultVO);
    }

    @PostMapping("/updateGoods")
    public ResponseBase modifyGoods(@RequestBody JSONObject jsonObject) {
        ResultVO resultVO = this.goodsInfoClient.updateGoods(jsonObject);
        return responseSuccess(resultVO);
    }
}
