package com.hcloud.microserver.bank.web;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.PayApplyClient;
import com.hcloud.microserver.facade.carbon.forms.OrderPayApplyForm;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/web/payApply")
public class PayApplyController extends CarbonBaseController {

    @Autowired
    private PayApplyClient payApplyClient;

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody OrderPayApplyForm orderPayApplyForm) {
        ResultVO resultVO = this.payApplyClient.searchByPage(orderPayApplyForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/audit")
    public ResponseBase audit(@RequestBody JSONObject jsonObject) {
        ResultVO resultVO = this.payApplyClient.audit(jsonObject);
        return responseSuccess(resultVO);
    }
}
