package com.hcloud.microserver.bank.web;

import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.PovertyAreaClient;
import com.hcloud.microserver.facade.carbon.forms.PovertyAreaForm;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Slf4j
@RestController
@RequestMapping("/web/area")
@Api(description = "贫困区域管理服务")
public class PovertyAreaController extends CarbonBaseController {

    @Autowired
    private PovertyAreaClient povertyAreaClient;

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody PovertyAreaForm povertyAreaForm) {
        ResultVO resultVO = this.povertyAreaClient.searchByPage(povertyAreaForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/save")
    public ResponseBase save(@RequestBody PovertyAreaForm povertyAreaForm) {
        povertyAreaForm.setCreateUser(this.getUserId());
        povertyAreaForm.setModifiedUser(this.getUserId());
        ResultVO resultVO = this.povertyAreaClient.save(povertyAreaForm);
        if (resultVO.getCode() == 0) {
            return responseSuccess(resultVO);
        }
        return responseError(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase update(@RequestBody PovertyAreaForm povertyAreaForm) {
        ResultVO resultVO = this.povertyAreaClient.update(povertyAreaForm);
        if (resultVO.getCode() == 0)
            return responseSuccess(resultVO);
        return responseError(resultVO);
    }

    @PostMapping("/del")
    public ResponseBase del(@RequestBody PovertyAreaForm povertyAreaForm) {
        ResultVO resultVO = this.povertyAreaClient.del(povertyAreaForm);
        if (resultVO.getCode() == 0)
            return responseSuccess(resultVO);
        return responseError(resultVO);
    }

    @GetMapping("/findByGuid")
    public ResponseBase findByGuid(@RequestParam(name = "guid") String guid) {
        ResultVO resultVO = this.povertyAreaClient.findByGuid(guid);
        return responseSuccess(resultVO);
    }
}
