package com.hcloud.microserver.bank.web;

import com.alibaba.fastjson.JSONObject;
import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.ProductInfoClient;
import com.hcloud.microserver.facade.carbon.forms.ProductInfoForm;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author xiezt
 */
@RestController
@RequestMapping("/web/product")
@Api(description = "产品信息管理服务")
public class ProductInfoController extends CarbonBaseController {

    @Autowired
    private ProductInfoClient productInfoClient;

    @PostMapping("/save")
    public ResponseBase save(@RequestBody ProductInfoForm productInfoForm) {
        ResultVO resultVO = this.productInfoClient.save(productInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/delete")
    public ResponseBase delete(@RequestBody ProductInfoForm productInfoForm) {
        ResultVO resultVO = this.productInfoClient.delete(productInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase update(@RequestBody ProductInfoForm productInfoForm) {
        ResultVO resultVO = this.productInfoClient.update(productInfoForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody ProductInfoForm productInfoForm) {
        ResultVO resultVO = this.productInfoClient.searchByPage(productInfoForm);
        if (resultVO.getCode() == 0) {
            return responseSuccess(resultVO);
        }
        return responseError(resultVO);
    }

    @PostMapping("/expansions")
    public ResponseBase expansions(@RequestParam("guid") String guid) {
        ResultVO resultVO = this.productInfoClient.expansions(guid);
        return responseSuccess(resultVO);
    }

    @PostMapping("/belongs")
    public ResponseBase belongs(@RequestParam("guid") String guid) {
        ResultVO resultVO = this.productInfoClient.belongs(guid);
        return responseSuccess(resultVO);
    }

    @PostMapping("/publish")
    public ResponseBase publish(@RequestBody JSONObject jsonObject) {
        ResultVO resultVO = this.productInfoClient.publish(jsonObject);
        return responseSuccess(resultVO);
    }

    @PostMapping("/publishGoods")
    public ResponseBase publishGoods(@RequestBody JSONObject jsonObject) {
        ResultVO resultVO = this.productInfoClient.publishGoods(jsonObject);
        return responseSuccess(resultVO);
    }

    @PostMapping("/findByGoodsInfoGuid")
    public ResponseBase findByGoodsInfoGuid(@RequestParam("goodsInfoGuid") String goodsInfoGuid) {
        ResultVO resultVO = this.productInfoClient.findByGoodsInfoGuid(goodsInfoGuid);
        return responseSuccess(resultVO);
    }
}
