package com.hcloud.microserver.bank.web;

import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.facade.carbon.client.ProductTypeClient;
import com.hcloud.microserver.facade.carbon.forms.ProductTypeForm;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @author xiezt
 */
@Slf4j
@RestController
@RequestMapping("/web/productType")
@Api(description = "产品类型信息管理服务")
public class ProductTypeController extends CarbonBaseController {

    @Autowired
    private ProductTypeClient productTypeClient;

    @PostMapping("/save")
    public ResponseBase save(@RequestBody ProductTypeForm productTypeForm) {
        ResultVO resultVO = this.productTypeClient.save(productTypeForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/delete")
    public ResponseBase delete(@RequestBody ProductTypeForm productTypeForm) {
        ResultVO resultVO = this.productTypeClient.delete(productTypeForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/update")
    public ResponseBase update(@RequestBody ProductTypeForm productTypeForm) {
        ResultVO resultVO = this.productTypeClient.update(productTypeForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody ProductTypeForm productTypeForm) {
        ResultVO resultVO = this.productTypeClient.searchByPage(productTypeForm);
        if (resultVO.getCode() == 0) {
            return responseSuccess(resultVO);
        }
        return responseError(resultVO);
    }

    @PostMapping("/expansions")
    public ResponseBase expansions(@RequestParam(name = "guid") String guid) {
        log.info("web =====> guid: {}", guid);
        ResultVO resultVO = this.productTypeClient.expansions(guid);
        return responseSuccess(resultVO);
    }

    @PostMapping("/all")
    public ResponseBase all(@RequestBody(required = false) ProductTypeForm productTypeForm) {
        ResultVO resultVO = this.productTypeClient.findAll(productTypeForm);
        return responseSuccess(resultVO);
    }

    @PostMapping("/checkTypeVal")
    public ResponseBase checkTypeVal(@RequestParam(name = "typeVal") String typeVal) {
        ResultVO resultVO = this.productTypeClient.checkTypeVal(typeVal);
        return responseSuccess(resultVO);
    }
}
