package com.hcloud.microserver.bank.web;

import com.hcloud.microserver.bank.common.CarbonBaseController;
import com.hcloud.microserver.commoncore.base.ResponseBase;
import com.hcloud.microserver.commoncore.base.ResultVO;
import com.hcloud.microserver.sys.facade.client.SysPermissionClient;
import com.hcloud.microserver.sys.facade.entity.SysPermission;
import com.hcloud.microserver.sys.facade.forms.SysPermissionForm;
import io.swagger.annotations.*;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@Slf4j
@RestController
@RequestMapping("/sys/permission")
@Api(description = "权限管理服务")
public class SysPermissionController extends CarbonBaseController {

    @Autowired
    private SysPermissionClient sysPermissionClient;

    @ApiOperation(value = "分页查询权限信息", notes = "默认分页参数pageNo, pageSize")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "sysPermissionForm", value = "权限管理页面参数对象", dataType = "SysPermissionForm")
    })
    @ApiResponse(code = 0, message = "操作成功")
    @PostMapping("/searchByPage")
    public ResponseBase searchByPage(@RequestBody SysPermissionForm sysPermissionForm) {
        ResultVO resultVO = sysPermissionClient.permissionList(sysPermissionForm);
        return responseSuccess(resultVO);
    }

    @ApiOperation(value = "权限列表", notes = "无分页参数")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "sysPermissionForm", value = "权限管理页面参数对象", dataType = "")
    })
    @ApiResponse(code = 0, message = "操作成功")
    @PostMapping("/list")
    public ResponseBase list(SysPermission sysPermission) {
        ResultVO resultVO = sysPermissionClient.list(sysPermission);
        return responseSuccess(resultVO);
    }
}
