package com.hcloud.microserver.commoncore.base;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;

import io.swagger.annotations.ApiModelProperty;

/**
 * @author xiezt
 */
@Data
public class BaseForm implements Serializable {

    protected Integer page = 0;

    protected Integer pageNo = 0;
    /**
     * 分页
     */
    protected Integer pageNum = 1;

    protected Integer pageSize = 10;

    protected Integer pageStart;

    protected Integer pageEnd;

    protected Integer limit = 0;

    protected String accessToken;

    protected String fkProductGuid;

    @ApiModelProperty(value="部门id",example="部门id")
    protected String fkOrgGuid;

    protected Integer state;

    protected String createUser;

    protected Date createTime;

    protected String modifiedUser;

    protected Date modifiedTime;

    protected String orgBrevity;

    protected String ico;
    
    /** 查询条件 */
    protected String params;

    /**
     * 溯源码url地址前缀
     */
    protected String codeUrlPrefix;

    /**
     * 登录用户guid
     */
    protected String loginOrgGuid;

    /**
     * 手机验证码
     */
    protected String msgCode;

    private void setLimit(Integer limit) {
        if (null != limit && limit != 0) {
            this.pageSize = limit;
        }
    }

    private void setPage(Integer page) {
        if (null != page && page != 0) {
            this.pageNo = page;
        }
    }

    /**
     * 店铺名称
     */
    protected String storeName;
}
