package com.hcloud.microserver.commoncore.base;

import lombok.Data;

import java.io.Serializable;

/**
 * @author apple
 * @date 2018/9/10
 */
@Data
public class PageBean<T extends Object> implements Serializable {

    /**
     * 当前页数
     */
    private Integer pnum = 0;
    /**
     * 分页条数
     */
    private Integer psize = 20;
    /**
     * 查询属性对象
     */
    private T data;

    /**
     * 排序字段
     */
    private String orderby;


    public PageBean() {

    }

    public PageBean(Integer pnum, Integer psize) {
        this.pnum = pnum;
        this.psize = psize;
        this.data = null;
    }

    public PageBean(Integer pnum, Integer psize, T data) {
        this.psize = psize;
        this.pnum = pnum;
        this.data = data;
    }

    public PageBean(T data) {
        this.data = data;
    }
}
