package com.hcloud.microserver.commoncore.conf;

import com.hcloud.microserver.commoncore.annotation.CurrentUser;
import com.hcloud.microserver.commoncore.constant.GlobleConstant;
import com.hcloud.microserver.commoncore.session.MemberInfo;
import com.hcloud.microserver.commoncore.session.UserInfo;
import org.springframework.core.MethodParameter;
import org.springframework.web.bind.support.WebDataBinderFactory;
import org.springframework.web.context.request.NativeWebRequest;
import org.springframework.web.context.request.RequestAttributes;
import org.springframework.web.method.support.HandlerMethodArgumentResolver;
import org.springframework.web.method.support.ModelAndViewContainer;


/**
 * @author xiezt
 */
public class CurrentUserMethodArgumentResolver implements HandlerMethodArgumentResolver {

    @Override
    public boolean supportsParameter(MethodParameter parameter) {
        if (parameter.hasParameterAnnotation(CurrentUser.class)) {
            if (parameter.getParameterType().isAssignableFrom(MemberInfo.class) || parameter.getParameterType()
                    .isAssignableFrom(UserInfo.class)) {
                return true;
            }
        }
        return false;
    }

    @Override
    public Object resolveArgument(MethodParameter parameter, ModelAndViewContainer mavContainer,
                                  NativeWebRequest webRequest, WebDataBinderFactory binderFactory) throws Exception {
        MemberInfo member = (MemberInfo) webRequest.getAttribute(GlobleConstant.CURRENT_MEMBER, RequestAttributes
                .SCOPE_REQUEST);
        if (member != null) {
            return member;
        }
        UserInfo user = (UserInfo) webRequest.getAttribute(GlobleConstant.CURRENT_USER, RequestAttributes
                .SCOPE_REQUEST);
        if (user != null) {
            return user;
        }
        return null;
//		throw new MissingServletRequestPartException(GlobleConstant.CURRENT_USER);
    }
}
