package com.hcloud.microserver.commoncore.enums;


import com.hcloud.microserver.commoncore.exception.GlobalException;

/**
 * @author xiezt
 */

public enum CommonEnum {
    MEN("男", 1),
    WOMEN("女", 2),

    INCREASE("增长", 1),
    FALLING("下降", 2),

    COUNTRY("country", 0),
    PROVINCE("province", 1),
    CITY("city", 2),
    DISTRICT("county", 3),
    TOWN("town", 4),
    VILLAGE("village", 5),

    SUCCESS("成功", 0),
    FAILURE("失败", 1),

    USER_CANCEL("用户已经注销，请联系管理员", 1001),
    PASSWORD_ERROR("密码错误", 1002),
    USER_UNREGISTERED_ERROR("用户未注册", 1003),
    RE_LOGIN("认证失败，请重新登录！", 1004),
    UNBOUND_REGION_ERROR("此账户未绑定区域，请联系管理员！", 1005),
    USER_NAME_REPEATED("用户名称已经存在", 1006),
    USER_TELEPHONE_REPEATED("电话号码已经存在", 1007),
    TELEPHONE_FORMAL_ERROR("电话号码格式错误", 1008),
    RE_LOGOUT("未正确退出,请重新退出", 1009),
    UNIQUE_CHECK_ERROR("重复", 1101),
    ENCRYPTION_ERROR("加密操作失败", 1102),
    ILLEGAL_PARAMETER_ERROR("参数非法", 2001),
    PARAMETER_NOT_NULL("参数不能为空", 2002),
    ID_NOT_NULL("id不能为空", 2009),
    TYPE_REFERENCED("类型被引用,请先删除引用", 2003),
    FILE_NOT_NULL("文件不能为空", 2004),
    FILE_CONTENT_NOT_NULL("文件内容不能为空", 2005),
    FILE_UPLOAD_FAIL("文件上传失败", 2006),
    DATE_TIME_FORMAT_ERR("请按正确的时间格式填写，格式为：年-月-日，例如：2018-06-28", 2007),
    COORDINATE_PARSE_ERROR("坐标解析错误", 2008),
    DEL_FAILURE("删除失败，对应用户不存在", 2009),
    DEL_CURRENT_LOGIN_INFO("不能修改当前登录人信息", 2010),
    DEL_ADMIN("不能修改超级管理员信息", 2011),
    PERCENT_TO_DOUBLE_ERROR("百分数转换double格式错误", 2012),
    PRODUCT_NAME_REPEATED("该商品已经存在", 3001),
    FILE_NOT_FOUND("文件不存在", 3002),
    FILE_REPEATED("文件已存在", 3003),
    MAX_UPLOAD_SIZE_EXCEEDED("文件过大无法上传", 3004),
    ROLE_NAME_REPEATED("角色名称已经存在", 3002),
    ROLE_MENU_NOT_FOUND("权限范围不可为空", 3014),
    MENU_NAME_REPEATED("菜单名称已经存在", 3003),
    PASSWORD_REPEAT("修改前后密码不能相同", 3004),
    USER_INFO_ERROR("用户信息有误", 3005),
    TOO_BIG_A_DOCUMENT("文件内容过大,无法上传", 3006),
    FILE_TYPE_ERROR("上传文件格式错误，仅支持.xls和.xlsx两种格式的文件", 3007),
    NUMBER_FORMAT("格式异常", 3009),
    FILE_CANNOT_BE_FOUND("文件未找到", 3010),
    DATE_TIME_PARSE("时间格式异常,请使用指定时间格式", 3011),
    OPERATOR_ERROR("不是对应办理人无法办理", 3012),
    RECOMMEND_EXCEED("推荐文章不能超过五条", 3013),
    AREA_ID_REPEATED("区域名称已经存在", 3015),
    AREA_ID_NOT_FOUND("区域名称不存在", 3016),
    CRAWLER_ASTRICT("省级账号才能查看爬虫信息", 3017),
    IP_ERROR("无效IP", 3018),
    ADMIN_ASTRICT("超级管理员不涉及业务操作", 3019),
    NO_AUTHORITY("权限不足，请联系管理员！", 3020),
    EVIDENCE_NOT_FOUND("请上传相应证据再进行举报", 3021),
    EXCEL_DATA_VOID("数据为空无法下载", 3022),
    AUTH_CODE_ERROR("验证码错误", 3023),
    TIME_TYPE_ERROR("时间类型只能为天（1）和月（3）", 3024),
    TITLE_IS_NULL("文章标题不能为空", 3025),
    IS_RECOMMEND_IS_NULL("文章需表明是否首页推荐", 3026),
    CONTENT_IS_NULL("文章内容不能为空", 3027),
    COVER_IS_NULL("推荐文章必须上传封面图片", 3028),
    AUTH_CODE_TIME_OUT("验证码超时", 3029),
    LOGIN_TIMEOUT("秘钥错误", 3030),
    AREA_NO_FOUND("地区不在当前用户范围内，请重新选择", 3031),
    DATA_ERROR("导入数据时间格式异常", 3032),
    INTEGER_VAIL("必须为整数", 3033),
    AREA_UNMATCH_ROLE("用户角色不在地区范围内，请重新选择", 3034),
    USER_INFO_RESTRICT("不是对应创建人无法进行相应操作", 3035),
    ARG_NO_FOUND("参数名称与系统中名称不匹配", 3036),
    DATA_NO_FOUND("导入数据中日期不能为空", 3037),
    PRODUCT_NAME_NO_FOUND("导入数据中产品名称不能为空", 3038),
    MARKET_NAME_FOUND("导入数据中市场名称不能为空", 3039),
    DEL_STATE("事件已举报完成,证据无法删除", 3040),
    ABNORMAL_ACCOUNT("账号异常", 3041),
    AREA_USER_FOUND("区域被用户引用,请先删除区域下的用户", 3042),
    ROLE_USER_FOUND("角色被用户引用,请先删除角色下的用户", 3043),
    ROLE_SYS("不可以删除系统默认创建的角色", 3044),
    ROLE_NO_FOUND("角色不存在", 3045),
    MENU_NO_FOUND("请增加上级和本级默认角色的菜单权限", 3046),
    AREA_NO_MATCH("只允许修改本级的菜单权限", 3047),
    ROLE_DEFAULT("只允许上级修改系统创建的默认角色", 3048),
    THE_CALLING_SYSTEM_DID_NOT_START("调用系统未正常启动", 3049),
    BUSINESS_INFORMATION_CANNOT_BE_EMPTY("农企信息不能为空", 3050),
    PRICING_RELEASES_CANNOT_BE_EMPTY("定价发布信息不能为空", 3051),
    THE_ACCOUNT_IS_BANNED("账号被禁,无法使用", 3052),
    THREAD_BLOCKING_EXCEPTION("账号被禁,无法使用", 3053),
    ROLE_OF_SPOT("不允许修改或删除收购点权限角色", 3054),
    INFORMATION_CANNOT_BE_REMOVED_BY_REFERENCE("信息被引用,无法删除", 3055),
    THE_CONTENT_IS_TOO_LARGE_TO_SAVE("内容过长无法保存", 3056),
    CANNOT_BE_DELETED_IN_USE("农企信息在使用中,不能删除", 3057),
    ACQUISITION_POINT_CANNOT_BE_EMPTY("收购点不能为空", 3058),
    COLLECTION_SPOT_NAME_REPEATED("收购点名称已存在", 3059),
    INTERNAL_ERROR("系统错误，请联系管理员！", 9999);


    private String value;
    private Integer index;

    CommonEnum(String sex, Integer index) {
        this.setValue(sex);
        this.setIndex(index);
    }

    public String getValue() {
        return value;
    }

    public static String getSex(Short index) {
        if (index.shortValue() == MEN.index.shortValue()) {
            return MEN.getValue();
        } else if (index.shortValue() == WOMEN.index.shortValue()) {
            return WOMEN.getValue();
        } else {
            return null;
        }
    }

    public static Short getIndex(String sex) {
        if (sex.trim().equals(MEN.value)) {
            return Short.valueOf(MEN.getIndex().toString());
        } else if (sex.trim().equals(WOMEN.value)) {
            return Short.valueOf(WOMEN.getIndex().toString());
        } else {
            throw new GlobalException("性别输入异常，性别只能为：男、女！");
        }
    }

    public Integer getIndex() {
        return index;
    }

    public void setValue(String value) {
        this.value = value;
    }

    public void setIndex(Integer index) {
        this.index = index;
    }
}
