package com.hcloud.microserver.commoncore.enums;

import lombok.Getter;

/**
 * 非过滤资源枚举
 */
@Getter
public enum NoAuthEnum {
    STATIC_IMAGES_PREFIX("/api/problem/images", "图片前缀"),
    STATIC_CSS_PREFIX("/api/problem/css", "样式前缀"),
    STATIC_JS_PREFIX("/api/problem/js", "样式前缀"),
    STATIC_ERROR_PREFIX("error", "另一个错误页面"),
    STATIC_ERRORHTML_PREFIX("errorHtml", "错误页面前缀"),
    H5_BEFORE_CHINA_PREFIX("wap/goods/searchForIndex","h5页面");
    /**
     * 前缀字符
     */
    private String prefixStr;
    /**
     * 前缀字符描述
     */
    private String prefixDes;

    private NoAuthEnum(String prefixStr, String prefixDes) {
        this.prefixStr = prefixStr;
        this.prefixDes = prefixDes;
    }

    /**
     * 判断方法字符串是否需要权限过滤
     *
     * @param methodStr
     * @return
     */
    public static boolean isNoAuth(String methodStr) {
        for (NoAuthEnum resultEnum : NoAuthEnum.values()) {
            String prefixStr = resultEnum.getPrefixStr();
            if (methodStr.indexOf(prefixStr) != -1) {
                return true;
            }
        }
        return false;
    }
}
