package com.hcloud.microserver.commoncore.enums;

import lombok.Getter;

/**
 * 平台机构权限枚举定义
 *
 * @author yys
 */
@Getter
public enum OrgAuthEnum {
    /**
     * 默认外网游客可访问
     */
    DEFAULT("0000", "游客可访问", "", ""),
    COMMON_PRO_SERVICE("COM0001", "公共wap API查询服务", "", ""),
    /**
     * 平台系统权限信息
     **/
    PLATFORM_AUTH_ADD("AUTH0001", "新增平台权限", "", "platform:sysauth:add"),
    PLATFORM_AUTH_QUERY("AUTH0002", "查询平台权限", "", "platform:sysauth:get"),
    PLATFORM_AUTH_EDIT("AUTH0003", "修改平台权限", "", "platform:sysauth:edit"),
    PLATFORM_AUTH_DELETE("AUTH0004", "删除平台权限", "", "platform:sysauth:del"),
    PLATFORM_AUTH_FORBIDDEN("AUTH0005", "禁用平台权限", "", "platform:sysauth:del"),
    PLATFORM_ORG_QUERY("ORG0001", "分页查询机构信息", "", "platform:sysorg:page"),
    PLATFORM_ORG_GET("ORG0002", "查询机构详细信息", "", "platform:sysorg:get"),
    PLATFORM_ORG_ADD("ORG0003", "添加机构信息", "", "platform:sysorg:add"),
    PLATFORM_ORG_EDIT("ORG0004", "编辑机构信息", "", "platform:sysorg:edit"),
    PLATFORM_ORG_DEL("ORG0005", "删除机构信息", "", "platform:sysorg:del"),
    PLATFORM_ORG_FORBIDDEN("ORG0006", "禁用机构信息", "", "platform:sysorg:forbidden"),
    PLATFORM_ORG_DIS_AUTH("ORG0007", "分配机构权限信息", "", "platform:sysorg:disauth"),
    PLATFORM_ORG_SEARCH_AUTH("ORG0008", "查询机构权限信息", "", "platform:sysorg:searchAuth"),
    PLATFORM_ORG_EXTENDS("ORG0009", "查询机构推广信息", "", "platform:sysorg:extends"),
    PLATFORM_ROLE_QUERY("ROLE0001", "分页查询角色记录", "", "platform:sysrole:page"),
    PLATFORM_ROLE_GET("ROLE0002", "查询角色明细信息", "", "platform:sysrole:get"),
    PLATFORM_ROLE_ADD("ROLE0003", "添加角色信息", "", "platform:sysrole:add"),
    PLATFORM_ROLE_EDIT("ROLE0004", "编辑角色信息", "", "platform:sysrole:edit"),
    PLATFORM_ROLE_DEL("ROLE0005", "删除角色信息", "", "platform:sysrole:del"),
    PLATFORM_ROLE_FORBIDDEN("ROLE0006", "禁用角色信息", "", "platform:sysrole:forbidden"),
    PLATFORM_ROLE_SEARCH_AUTH("ROLE0007", "查询角色权限信息", "", "platform:sysrole:search:auth"),
    PLATFORM_ROLE_DIS_AUTH("ROLE0008", "分配角色权限信息", "", "platform:sysrole:distrib"),
    PLATFORM_USER_QUERY("USR0001", "分页查询平台账户信息", "", "platform:sysuser:search"),
    PLATFORM_USER_GET("USR0002", "查询平台账户信息", "", "platform:sysuser:get"),
    PLATFORM_USER_ADD("USR0003", "添加平台账户信息", "", "platform:sysuser:add"),
    PLATFORM_USER_EDIT("USR0004", "修改平台账户信息", "", "platform:sysuser:edit"),
    PLATFORM_USER_DEL("USR0005", "删除平台用户信息", "", "platform:sysuser:del"),
    PLATFORM_USER_FORBIDDEN("USR0006", "禁用用户权限信息", "", "platform:sysuser:forbidden"),
    PLATFORM_USER_SEARCH_AUTH("USR0007", "查询用户权限信息", "", "platform:sysuser:search:auth"),
    /**
     * 平台溯源商品权限信息
     **/
    PLATFORM_GOODS_INFO_QUERY("GOODS0001", "分页查询商品信息", "", "platform:goods:product:page"),
    PLATFORM_GOODS_INFO_GET("GOODS0002", "查询商品信息", "", "platform:goods:product:get"),
    PLATFORM_GOODS_INFO_ADD("GOODS0003", "添加商品信息", "", "platform:goods:product:add"),
    PLATFORM_GOODS_INFO_EDIT("GOODS0004", "编辑商品信息", "", "platform:goods:product:edit"),
    PLATFORM_GOODS_INFO_DEL("GOODS0005", "删除商品信息", "", "platform:goods:product:del"),
    PLATFORM_GOODS_BATCH_QUERY("GOODS0006", "查询商品批次信息列表", "", "platform:goods:batch:list"),
    PLATFORM_GOODS_BATCH_GET("GOODS0007", "获取商品批次明细信息", "", "platform:goods:batch:get"),
    PLATFORM_GOODS_BATCH_ADD("GOODS0008", "添加商品批次信息", "", "platform:goods:batch:add"),
    PLATFORM_GOODS_BATCH_EDIT("GOODS0009", "编辑商品批次信息", "", "platform:goods:batch:edit"),
    PLATFORM_GOODS_BATCH_DEL("GOODS0010", "删除商品批次信息", "", "platform:goods:batch:del"),
    PLATFORM_GOODS_BATCH_CODE("GOODS0011", "生成商品溯源码", "", "platform:goods:batch:code"),
    PLATFORM_GOODS_FIELD_QUERY("FIELDS0001", "查询产地信息列表", "", "platform:goods:field:list"),
    PLATFORM_GOODS_FIELD_GET("FIELD0002", "查询产地明细信息", "", "platform:goods:field:get"),
    PLATFORM_GOODS_FIELD_ADD("FIELD0003", "添加产地信息", "", "platform:goods:field:add"),
    PLATFORM_GOODS_FIELD_EDIT("FIELD0004", "编辑产地信息", "", "platform:goods:field:edit"),
    PLATFORM_GOODS_FIELD_DEL("FIELD0004", "删除产地信息", "", "platform:goods:field:del"),
    PLATFORM_GOODS_CODE_QUERY("CODE0001", "分页查询码生成记录", "", "platform:goods:qrcode:list"),
    PLATFORM_GOODS_CODE_GET("CODE0002", "溯源码效果预览", "", "platform:goods:qrcode:get"),
    PLATFORM_GOODS_CODE_EXPORT("CODE0003", "导出溯源码生成记录", "", "platform:goods:qrcode:export"),
    PLATFORM_GOODS_CODE_ABOLISH("CODE0004", "废除溯源码生成记录", "", "platform:goods:qrcode:abolish"),
    PLATFORM_GOODS_CODE_DETAIL("CODE0005", "查询溯源码生成明细", "", "platform:goods:qrcode:detail"),
    PLATFORM_GOODS_CODE_DEL("CODE0006", "删除溯源码生成记录", "", "platform:goods:qrcode:del"),
    PLATFORM_GOODS_CODE_PRINT("CODE0007", "打印溯源码", "", "platform:goods:qrcode:print"),
    
    PLATFORM_SYS_DEALER("DEAL0001", "经销商信息管理列表", "", "platform:sys:dealer"),
    PLATFORM_SYS_DEALER_ADD("DEAL0002", "添加经销商信息", "", "platform:sys:dealer:add"),
    PLATFORM_SYS_DEALER_EDIT("DEAL0003", "修改经销商信息", "", "platform:sys:dealer:edit"),
    PLATFORM_SYS_DEALER_DEL("DEAL0004", "删除经销商信息", "", "platform:sys:dealer:del"),
    
    PLATFORM_GOODS_CODE_STAT_ONE_YEAR_SCAN_NUMS("CODE0007", "统计一年各月扫码人数", "统计一年各月扫码人数",
            "platform:goods:qrcode:statOneYear"),
    PLATFORM_GOODS_CODE_STAT_YESTERDAY_AND_ALL_TIME_SCAN_NUMS("CODE0008", "统计昨天和历史累计扫码人数", "统计昨天和历史累计扫码人数",
            "platform:goods:qrcode:statYesterdayAndAllTime"),
    PLATFORM_GOODS_CODE_STAT_ONE_DAY_SCAN_NUMS("CODE0009", "统计当天各小时扫码人数", "统计当天各小时扫码人数",
            "platform:goods:qrcode:statOneDayAllHours"),
    PLATFORM_GOODS_CODE_STAT_ONE_WEEK_SCAN_NUMS("CODE0010", "统计一周7天每天的扫码人数", "统计的是自然周不是过去7天",
            "platform:goods:qrcode:statOneWeekSevenDays"),
    PLATFORM_GOODS_CODE_STAT_ONE_MONTH_SCAN_NUMS("CODE0011", "统计本月每天的扫码人数", "统计本月每天的扫码人数",
            "platform:goods:qrcode:statOneMonthAllDays");
    


    /**
     * 权限编码
     */
    private String authCode;
    /**
     * 权限名称
     */
    private String authName;

    /**
     * 权限描述字符
     */
    private String authTarget;
    /**
     * 权限描述
     */
    private String description;

    OrgAuthEnum(String authCode, String authName, String description, String authTarget) {
        this.authCode = authCode;
        this.authName = authName;
        this.description = description;
        this.authTarget = authTarget;
    }
}
