package com.hcloud.microserver.commoncore.filter;

import com.hcloud.microserver.commoncore.web.BodyReaderHttpServletRequestWrapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.servlet.*;
import javax.servlet.annotation.WebFilter;
import javax.servlet.http.HttpServletRequest;
import java.io.IOException;

@WebFilter(filterName = "requestBodyFilter", urlPatterns = "/*")
@Component
@Slf4j
public class HttpRequestMyFilter implements Filter {

    private static final String HTTP_REQUEST_METHOD_POST = "POST";

    @Override
    public void init(FilterConfig filterConfig) throws ServletException {

    }

    @Override
    public void doFilter(ServletRequest servletRequest, ServletResponse servletResponse, FilterChain filterChain)
            throws IOException, ServletException {
        log.info("servletRequest is :{}", servletRequest);
        HttpServletRequest httpServletRequest = (HttpServletRequest) servletRequest;
        String requestMethod = httpServletRequest.getMethod().toUpperCase();
        if (HTTP_REQUEST_METHOD_POST.equals(requestMethod)) {
            ServletRequest requestWrapper = new BodyReaderHttpServletRequestWrapper(httpServletRequest);
            filterChain.doFilter(requestWrapper, servletResponse);
        } else {
            filterChain.doFilter(servletRequest, servletResponse);
        }
    }

    @Override
    public void destroy() {

    }
}
