package com.hcloud.microserver.commoncore.session;

import java.math.BigDecimal;
import java.util.Date;

import lombok.Data;

/**
 * 前台用户信息缓存对象
 *
 * @author yys
 */
@Data
public class MemberInfo {

    private Integer id;
    /**
     * 用户名
     */
    private String username;
    /**
     * 密码
     */
    private String password;
    /**
     * 手机
     */
    private String mobile;
    /**
     * 生日
     */
    private Date birthday;
    /**
     * 信誉额度
     */
    private BigDecimal credit;
    /**
     * 是否启用，0为启用  1 不启用
     */
    private Integer lock;
    /**
     * 注册时间
     */
    private String addTime;
    /**
     * 邮箱
     */
    private String email;
    /**
     * 手机是否验证 0否；1是
     */
    private Integer mobileStatus;
    /**
     * 最后一次登录时间
     */
    private Integer loginTime;
    /**
     * 最后一次登录ip
     */
    private String loginIp;
    /**
     * 邮箱是否验证 0否；1是
     */
    private Integer emailStatus;
    /**
     * 身份证号码
     */
    private String idNumber;
    /**
     * 用户编号
     */
    private Integer codeId;
    /**
     * 注册来源 0 前台注册 1 后台注册
     */
    private Integer source;
    /**
     * 创建ip
     */
    private String createIp;
    /**
     * 昵称
     */
    private String nickname;
    /**
     * 头像
     */
    private String headerPic;
    /**
     * 登录次数
     */
    private Integer loginCount;
    /**
     * 微信openId
     */
    private String openId;
    /**
     * 奖励
     */
    private BigDecimal reward;
    /**
     * 邀请人Id
     */
    private Integer inviteId;
    /**
     * 错误登录时间
     */
    private Integer errorLoginTime;
    /**
     * 错误登录次数
     */
    private Integer errorCount;
    /**
     * QQ openId
     */
    private String qqOpenId;
    /**
     * 新浪openId
     */
    private String sinaOpenId;
    /**
     * 余额
     */
    private BigDecimal balance;
    /**
     * 已提现金额
     */
    private BigDecimal isMoney;
    /**
     * 提现中金额
     */
    private BigDecimal runMoney;

}
