package com.hcloud.microserver.commoncore.util;

import lombok.extern.slf4j.Slf4j;

import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author xiezt
 */
@Slf4j
public class BusinessCodeRule {

    private static final SimpleDateFormat SDF = new SimpleDateFormat("yyyyMMdd");

    private static final SimpleDateFormat YEAR_SDF = new SimpleDateFormat("yy");

    public static String commonCodeRule(Integer currentMaxNumber, Integer incrementLen) {
        StringBuilder sb = new StringBuilder();
        currentMaxNumber++;
        String prefixed = SDF.format(new Date());
        sb.append(prefixed);
        Integer mutilLen = incrementLen - String.valueOf(currentMaxNumber).length();
        for (int i = 0; i < mutilLen; i++) {
            sb.append("0");
        }
        sb.append(currentMaxNumber);
        return sb.toString();
    }

    public static String firstSpecialCodeRule(String prefixed,Integer currentMaxNumber, Integer incrementLen){
        StringBuilder sb = new StringBuilder();
        currentMaxNumber++;
        String currentYearStr = YEAR_SDF.format(new Date());
        sb.append(prefixed);
        sb.append(currentYearStr);
        Integer mutilLen = incrementLen - sb.toString().length() - String.valueOf(currentMaxNumber).length();
        for (int i = 0; i < mutilLen; i++) {
            sb.append("0");
        }
        sb.append(currentMaxNumber);
        return sb.toString();
    }

    public static String secondSpecialCodeRule(String prefixed,Integer currentMaxNumber, Integer incrementLen){
        StringBuilder sb = new StringBuilder();
        currentMaxNumber++;
        String currentYearStr = SDF.format(new Date());
        sb.append(prefixed);
        sb.append(currentYearStr);
        Integer mutilLen = incrementLen - sb.toString().length() - String.valueOf(currentMaxNumber).length();
        for (int i = 0; i < mutilLen; i++) {
            sb.append("0");
        }
        sb.append(currentMaxNumber);
        return sb.toString();
    }

    public static String notYearCodeRule(String prefixed,Integer currentMaxNumber, Integer incrementLen){
        StringBuilder sb = new StringBuilder();
        currentMaxNumber++;
        sb.append(prefixed);
        Integer mutilLen = incrementLen - sb.toString().length() - String.valueOf(currentMaxNumber).length();
        for (int i = 0; i < mutilLen; i++) {
            sb.append("0");
        }
        sb.append(currentMaxNumber);
        return sb.toString();
    }

}
