package com.hcloud.microserver.commoncore.util;


import com.hcloud.microserver.commoncore.util.export.DataField;
import com.hcloud.microserver.commoncore.util.export.DataPage;
import com.hcloud.microserver.commoncore.util.export.ExportDataSource;
import com.hcloud.microserver.commoncore.util.export.excel.ExcelDataExportor;
import com.hcloud.microserver.commoncore.util.export.excel.MODE;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.FileCopyUtils;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLDecoder;
import java.util.List;
import java.util.Map;

@Slf4j
public class ExportExcelUtil {

    public static void exportExcel(HttpServletResponse httpResponse, final List<Map<String, String>> export
            , DataField[] fields, String fileName) {
        try {
            log.info("web dir======================>{}", FilePathUtil.getClassseDirOrPath());
            //不使用固定文件避免多线程同时占用
            String fileUrl = FilePathUtil.getClassseDirOrPath() + "excelMode/" + System.currentTimeMillis() + ".xls";
            if (fileUrl.indexOf("%") >= 0) {
                fileUrl = URLDecoder.decode(fileUrl, "utf-8");
            }
            File file = new File(fileUrl);
            // 准备好一个输出的对象
            OutputStream out = new FileOutputStream(file);


            ExportDataSource<String> dataSource = new ExportDataSource<String>() {
                @SuppressWarnings("unchecked")
                @Override
                public List<Map<String, String>> getData() {
                    return export;
                }
            };
//			ExcelDataExportor<String> s = new ExcelDataExportor<String>(,fields, dataSource, out,MODE.EXCEL);
            DataPage pageParam = new DataPage(10000);
            ExcelDataExportor<String> s = new ExcelDataExportor<String>(pageParam, fields, dataSource, out, MODE.EXCEL);
            s.export();
            out.close();

            File file1 = new File(fileUrl);
            FileInputStream fileInput = new FileInputStream(file1);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();

            byte[] buffer = new byte[1024 * 4];
            int n = -1;
            while ((n = fileInput.read(buffer)) != -1) {
                baos.write(buffer, 0, n);
            }
            byte[] byteArray = baos.toByteArray();
            InputStream inputStream = new ByteArrayInputStream(byteArray);

            httpResponse.setHeader("Cache-Control", "private");
            httpResponse.setHeader("Pragma", "private");
            httpResponse.setContentType("xls");
            httpResponse.setHeader("Content-Type", "application/force-download");
//			httpResponse.setHeader("Content-Disposition", "attachment; filename="+fileName+".xls");
            httpResponse.setHeader("Content-Disposition", "attachment; filename=" + new String(fileName.getBytes
                    ("UTF-8"), "ISO-8859-1") + ".xls");
            FileCopyUtils.copy(inputStream, httpResponse.getOutputStream());
            httpResponse.flushBuffer();
            fileInput.close();//关闭文件
            //删除文件
            if (!file.isDirectory()) {
                file.delete();
            }
            inputStream.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void exportExcelForBoot(HttpServletResponse httpResponse, final List<Map<String, String>> export
            , DataField[] fields, String fileName, String filePath) {
        InputStream inputStream = null;
        try {
            String fileUrl = filePath + System.currentTimeMillis() + ".xls";
            File file = new File(fileUrl);
            // 准备好一个输出的对象
            OutputStream out = new FileOutputStream(file);
            ExportDataSource<String> dataSource = new ExportDataSource<String>() {
                @SuppressWarnings("unchecked")
                @Override
                public List<Map<String, String>> getData() {
                    return export;
                }
            };
            DataPage pageParam = new DataPage(10000);
            ExcelDataExportor<String> s = new ExcelDataExportor(pageParam, fields, dataSource, out, MODE.EXCEL);
            s.export();
            out.close();
            File file1 = new File(fileUrl);
            FileInputStream fileInput = new FileInputStream(file1);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();
            byte[] buffer = new byte[1024 * 4];
            int n = -1;
            while ((n = fileInput.read(buffer)) != -1) {
                baos.write(buffer, 0, n);
            }
            byte[] byteArray = baos.toByteArray();
            inputStream = new ByteArrayInputStream(byteArray);
            httpResponse.setHeader("Cache-Control", "private");
            httpResponse.setHeader("Pragma", "private");
            httpResponse.setContentType("xls");
            httpResponse.setHeader("Content-Type", "application/octet-stream");
            httpResponse.setHeader("Content-Disposition", "attachment; filename=" + new String(fileName.getBytes
                    ("UTF-8"), "ISO-8859-1") + ".xls");
            FileCopyUtils.copy(inputStream, httpResponse.getOutputStream());
            httpResponse.flushBuffer();
            fileInput.close();//关闭文件
            //删除文件
            if (!file.isDirectory()) {
                file.delete();
            }
            inputStream.close();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                inputStream.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static void exportExcelByObject(HttpServletResponse httpResponse, final List<Map<String, Object>> export
            , DataField[] fields, String fileName) {
        try {
            String fileUrl = FilePathUtil.getClassseDirOrPath() + "excelMode/" + System.currentTimeMillis() + ".xls";
            //不使用固定文件避免多线程同时占用
            if (fileUrl.indexOf("%") >= 0) {
                fileUrl = URLDecoder.decode(fileUrl, "utf-8");
            }
            File file = new File(fileUrl);
            OutputStream out = new FileOutputStream(file); // 准备好一个输出的对象

            ExportDataSource<String> dataSource = new ExportDataSource<String>() {
                @SuppressWarnings("unchecked")
                @Override
                public List<Map<String, Object>> getData() {
                    return export;
                }
            };
//			ExcelDataExportor<String> s = new ExcelDataExportor<String>(fields, dataSource, out,MODE.EXCEL);
            DataPage pageParam = new DataPage(10000);
            ExcelDataExportor<String> s = new ExcelDataExportor<String>(pageParam, fields, dataSource, out, MODE.EXCEL);
            s.export();
            out.close();

            File file1 = new File(fileUrl);
            FileInputStream fileInput = new FileInputStream(file1);
            ByteArrayOutputStream baos = new ByteArrayOutputStream();

            byte[] buffer = new byte[1024 * 4];
            int n = -1;
            while ((n = fileInput.read(buffer)) != -1) {
                baos.write(buffer, 0, n);
            }
            byte[] byteArray = baos.toByteArray();
            InputStream inputStream = new ByteArrayInputStream(byteArray);

            httpResponse.setHeader("Cache-Control", "private");
            httpResponse.setHeader("Pragma", "private");
            httpResponse.setContentType("xls");
            httpResponse.setHeader("Content-Type", "application/force-download");

            httpResponse.setHeader("Content-Disposition", "attachment; filename=" + new String(fileName.getBytes
                    ("UTF-8"), "ISO-8859-1") + ".xls");
//			headers.add("Content-disposition","attachment;filename="+new String("中国".getBytes("UTF-8"),"ISO-8859-1")+"
// .txt");
            FileCopyUtils.copy(inputStream, httpResponse.getOutputStream());
            httpResponse.flushBuffer();
            fileInput.close();//关闭文件
            //删除文件
            if (!file.isDirectory()) {
                file.delete();
            }
            inputStream.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
