package com.hcloud.microserver.commoncore.util;

import java.net.URLDecoder;

public class FilePathUtil {
    private static final String Java_Dir = "WEB-INF/classes";

    public FilePathUtil() {
    }

    public static String getWebDirOrPath() {
        String classPath = null;

        try {
            classPath = getClassseDirOrPath();
        } catch (Exception var3) {
            var3.printStackTrace();
        }

        if (classPath.indexOf("%") >= 0) {
            try {
                classPath = URLDecoder.decode(classPath, "utf-8");
            } catch (Exception var2) {
                var2.printStackTrace();
            }
        }

        int index = classPath.indexOf("WEB-INF");
        return index > 0 ? classPath.substring(0, index) : null;
    }

    public static String getClassseDirOrPath() {
        try {
            String e = FilePathUtil.class.getProtectionDomain().getCodeSource().getLocation().getFile();
            if (e.indexOf("WEB-INF") > 0) {
                e = e.substring(0, e.indexOf("WEB-INF") + 7) + "/classes/";
                return e;
            } else {
                return e;
            }
        } catch (Exception var1) {
            var1.printStackTrace();
            return null;
        }
    }

    public static String getWebDirOrPath(String file) {
        return getWebDirOrPath() + file;
    }

    public static String getJavaClassRootPath() {
        return getWebDirOrPath() + "WEB-INF/classes" + "/";
    }

    public static String getClassseDirOrPtah(String path) {
        return getClassseDirOrPath() + path;
    }


}
