package com.hcloud.microserver.commoncore.util;

import com.hcloud.microserver.commoncore.util.string.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.io.File;
import java.io.FileOutputStream;
import java.util.UUID;

/**
 * @author JYJ
 */
@Slf4j
public class FileUtil {

    public static void uploadFile(byte[] file, String filePath, String fileName) throws Exception {
        File targetFile = new File(filePath);
        if (!targetFile.exists()) {
            targetFile.mkdirs();
        }
        FileOutputStream out = null;
        try {
            out = new FileOutputStream(filePath + fileName);
            out.write(file);
            out.flush();
            out.close();
        } catch (Exception e) {
            log.error("filePath================{},fileName===========>{}", filePath, fileName);
        } finally {
            out.close();
        }

    }

    public static boolean deleteFile(String fileName) {
        File file = new File(fileName);
        // 如果文件路径所对应的文件存在，并且是一个文件，则直接删除
        if (file.exists() && file.isFile()) {
            if (file.delete()) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    public static String renameToUUID(String fileName) {
        return StrUtil.get32UUID() + "." + fileName.substring(fileName.lastIndexOf(".") + 1);
    }
}
