package com.hcloud.microserver.commoncore.util;

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.multipart.MultipartFile;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.Random;
import java.util.UUID;

@Slf4j
public class GetUUID {

    public static String getUUID() {
        UUID uuid = UUID.randomUUID();
        String str = uuid.toString();
        String uuidStr = str.replace("-", "");
        return uuidStr;
    }

    //生成唯一订单号
    public static String getOrderNum() {
        //生成唯一订单号
        int machineId = 1;//最大支持1-9个集群机器部署
        int hashCodeV = UUID.randomUUID().toString().hashCode();
        if (hashCodeV < 0) {//有可能是负数
            hashCodeV = -hashCodeV;
        }
        DateFormat dateFormat = new SimpleDateFormat("yyyyMMdd");
        String result = dateFormat.format(new Date());
        String AAA = result + machineId + String.format("%06d", hashCodeV);
        log.error("订单号生成成功:{}", AAA);
        return AAA;
    }

    /**
     * 生成唯一订单号
     * @param prefixed
     * @return
     */
    public static String getOrderNum(String prefixed) {
        StringBuffer sbb = new StringBuffer(prefixed);
        //生成唯一订单号
        int machineId = 1;
        //最大支持1-9个集群机器部署
        int hashCodeV = UUID.randomUUID().toString().hashCode();
        if (hashCodeV < 0) {
            //有可能是负数
            hashCodeV = -hashCodeV;
        }
        DateFormat dateFormat = new SimpleDateFormat("yyyyMMdd");
        String result = dateFormat.format(new Date());
        sbb.append(result).append(machineId).append(String.format("%06d", hashCodeV));
        String AAA =sbb.toString();
        log.error("订单号生成成功:{}", AAA);
        return AAA;
    }

    /**
     * 按时间生成订单号
     * @return
     */
    public static String dateUtilCode() {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmssSSS");
        Date date = new Date();
        String code = sdf.format(date);
        return code;
    }

    /**
     * 此函数实现：给定日期和经过天数，算出结果日期
     *
     * @param sDate 为指定日期
     * @param iDate iDate为多少时间段（可以是 年、月、日...  具体根据iCal来确定）
     * @param iCal  iCal为某种时间段例如  月：Calendar.MONTH（具体可查询api中Calendar类）
     * @return
     */
    public static String getNextDate(String sDate, int iDate, int iCal, String Str) {
        String sNextDate = "";
        Calendar calendar = Calendar.getInstance();
        SimpleDateFormat formatter = new SimpleDateFormat(Str);
        Date date = null;
        try {
            date = formatter.parse(sDate);
        } catch (ParseException e) {
            e.printStackTrace();
        }
        calendar.setTime(date);
        calendar.add(iCal, iDate);
        sNextDate = formatter.format(calendar.getTime());
        return sNextDate;
    }

    public static String getRandom(int length) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        String str = sdf.format(new Date());
        String var = "";
        for (int i = 0; i < length; i++) {
            //加上一些字母，就可以生成pc站的验证码了
            String sources = "0123456789";
            Random rand = new Random();
            StringBuffer flag = new StringBuffer();
            for (int j = 0; j < length; j++) {
                flag.append(sources.charAt(rand.nextInt(9)) + "");
            }
            var = flag.toString();
        }
        var = str + var;
        return var;
    }

}