package com.hcloud.microserver.commoncore.util;

import java.util.Collection;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;

/**
 * 日志格式化工具
 *
 * @author yys
 */
public class LogUtil {

    /**
     * 对象信息格式化为json字符串
     *
     * @param object
     * @return
     */
    public static String formatJson(Object object) {
        String formatJson = "";
        if (object != null && object instanceof Collection) {
            int size = ((Collection<?>) object).size();
            if (size > 100) {
                formatJson = "size:" + size + "";
                return formatJson;
            }

        }
        formatJson += formatJson(JSONObject.toJSONString(object, SerializerFeature.WriteMapNullValue,
                SerializerFeature.WriteDateUseDateFormat));
        // formatJson+=JSONObject.toJSONString(object,SerializerFeature.WriteMapNullValue,SerializerFeature
        // .WriteDateUseDateFormat);
        return formatJson;
    }

    /**
     * 格式化json字符串
     *
     * @param jsonStr
     * @return
     */
    private static String formatJson(String jsonStr) {
        if (null == jsonStr || "".equals(jsonStr))
            return "";
        StringBuilder sb = new StringBuilder("json:\n");
        char last = '\0';
        char current = '\0';
        int indent = 0;
        boolean isInQuotationMarks = false;
        for (int i = 0; i < jsonStr.length(); i++) {
            last = current;
            current = jsonStr.charAt(i);
            switch (current) {
                case '"':
                    if (last != '\\') {
                        isInQuotationMarks = !isInQuotationMarks;
                    }
                    sb.append(current);
                    break;
                case '{':
                case '[':
                    sb.append(current);
                    if (!isInQuotationMarks) {
                        sb.append('\n');
                        indent++;
                        addIndentBlank(sb, indent);
                    }
                    break;
                case '}':
                case ']':
                    if (!isInQuotationMarks) {
                        sb.append('\n');
                        indent--;
                        addIndentBlank(sb, indent);
                    }
                    sb.append(current);
                    break;
                case ',':
                    sb.append(current);
                    if (last != '\\' && !isInQuotationMarks) {
                        sb.append('\n');
                        addIndentBlank(sb, indent);
                    }
                    break;
                default:
                    sb.append(current);
            }
        }
        return sb.toString();
    }

    /**
     * 添加空格: <br>
     *
     * @param sb
     * @param indent
     */
    private static void addIndentBlank(StringBuilder sb, int indent) {
        for (int i = 0; i < indent; i++) {
            sb.append('\t');
        }
    }

}
