package com.hcloud.microserver.commoncore.util;

import org.apache.commons.net.util.Base64;

import java.io.UnsupportedEncodingException;
import java.security.MessageDigest;

public class Md5Util {

    // MD5加密
    public static String toMD5(String plainText) {
        String newPwd = "";
        try {
            // 生成实现指定摘要算法的 MessageDigest 对象。
            MessageDigest md = MessageDigest.getInstance("MD5");
            // 使用指定的字节数组更新摘要。
            md.update(plainText.getBytes());
            // 通过执行诸如填充之类的最终操作完成哈希计算。
            byte b[] = md.digest();
            // 生成具体的md5密码到buf数组
            int i;
            StringBuffer buf = new StringBuffer("");
            for (int offset = 0; offset < b.length; offset++) {
                i = b[offset];
                if (i < 0) {
                    i += 256;
                }
                if (i < 16) {
                    buf.append("0");
                }
                buf.append(Integer.toHexString(i));
            }
            newPwd = buf.toString();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return newPwd;
    }

    /**
     * MD5加密
     */
    public static String md5(String encryptedObject) {
        try {
            char[] hexDigits = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C',
                    'D', 'E', 'F'};
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            md5.update(encryptedObject.getBytes());

            byte[] digest = md5.digest();
            int j = digest.length;
            char[] chars = new char[j * 2];
            int k = 0;
            for (int i = 0; i < j; i++) {
                byte byte0 = digest[i];
                chars[k++] = hexDigits[byte0 >>> 4 & 0xf];
                chars[k++] = hexDigits[byte0 & 0xf];
            }
            return new String(chars);
        } catch (Exception e) {
            throw new RuntimeException();
        }
    }

    /**
     * 登录解密方式
     *
     * @param pwd
     * @return
     */
    public static String checkoutPwd(String pwd) {
        //需要进行对应的接密操作
        //1.获取盐值
        String salt = pwd.substring(0, 5);
        String key = "b8d11ee289394be688ef3a4f6968efed";
        String time1 = Md5Util.md5((key).substring(0, 8)).substring(0, 5);
        //做超时判断
        if (!time1.equalsIgnoreCase(salt)) {
            throw new RuntimeException();
        }
        //2.去除盐值
        String replace = pwd.replace(salt, "");
        //3.还原base64前的密码值
        try {
            return new String(Base64.decodeBase64(replace), "utf-8");
        } catch (UnsupportedEncodingException e) {
            throw new RuntimeException();
        }
    }

}
