package com.hcloud.microserver.commoncore.util;

import com.alibaba.excel.EasyExcel;
import com.jcraft.jsch.*;
import lombok.Data;
import org.springframework.stereotype.Component;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Properties;

@Data
public class SftpUtils<T> {

    private List<T> list;
    private String fileName;
    private String path;
    private String excelName;
    private String sheetName;
    private String pathUrl;
    private String ftpHost;
    private String userName;
    private int port;
    private String uploadUrl;
    private String password;
    private SimpleDateFormat simple = new SimpleDateFormat("yyyyMMddHHmmss");

    public void makeExcelLog(Class header){

        String fileName = excelName+simple.format(new Date())+".xlsx";
        this.setFileName(fileName);
        String pathUrl = path+ fileName;
        this.setPathUrl(pathUrl);
        EasyExcel.write(pathUrl,header).sheet("农户上传情况").doWrite(list);
    }
    public void pushSft(){
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyyMM");

        JSch jSch = new JSch();

        try {
            //获取一个Linux会话
            Session session = jSch.getSession(userName, ftpHost, port);
            //设置登录密码
            session.setPassword(password);
            //关闭key的检验
            Properties sshConfig = new Properties();
            sshConfig.put("StrictHostKeyChecking", "no");
            session.setConfig(sshConfig);
            //连接Linux
            session.connect();
            //通过sftp的方式连接
            ChannelSftp channel = (ChannelSftp) session.openChannel("sftp");
            channel.connect();
            //上传文件
            File file = new File(pathUrl);
            InputStream inputStream = new FileInputStream(file);
            String formatStr = simpleDateFormat.format(new Date());
            channel.cd(uploadUrl);
            try {

                channel.cd(uploadUrl+formatStr);
            }catch (Exception e){

                channel.mkdir(formatStr);
            }
            channel.put(inputStream, uploadUrl+formatStr+"/"+fileName);
            inputStream.close();
            File files = new File(pathUrl);
            if (files.exists()){
                files.delete();
            }

        } catch (JSchException e) {
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }catch (Exception e) {
            e.printStackTrace();
        }

    }
}
