package com.hcloud.microserver.commoncore.util;

import com.hcloud.microserver.commoncore.util.string.StrUtil;
import lombok.extern.slf4j.Slf4j;

import java.util.Arrays;
import java.util.List;

/**
 * @author JYJ
 */
@Slf4j
public class TracedCodeUtils {

    private static final Integer[] ASCII_NUM = {65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77,
            78, 79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90};
    private static final String[] ASCII_WORD = {"A", "B", "C", "D", "E", "F", "G", "H", "I", "J",
            "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T",
            "U", "V", "W", "X", "Y", "Z"};

    /**
     * 生成溯源数字查询码
     *
     * @param flagCode
     * @param originalCode
     * @return
     */
    public static String generalTracedCode(String flagCode, String originalCode, List<String> containerList) {
        StringBuilder sbb = new StringBuilder(flagCode);
        StringBuilder ssbb = new StringBuilder();
        String randomNum = StrUtil.get36UUID();
        String strRandom = randomNum.split("-")[0].toUpperCase();
        List<String> arrayList = Arrays.asList(strRandom.split(""));
        for (int i = 0; i < arrayList.size(); i++) {
            String tmp = arrayList.get(i);
            if (!StrUtil.isNumeric(tmp)) {
                for (int j = 0; j < ASCII_WORD.length; j++) {
                    String inner = ASCII_WORD[j];
                    if (tmp.equalsIgnoreCase(inner)) {
                        ssbb.append(ASCII_NUM[j] / 10);
                        break;
                    }
                }
            } else {
                ssbb.append(tmp);
            }
        }
        String code = sbb.append(ssbb.toString()).toString();
        if (!containerList.contains(code)) {
            containerList.add(code);
            return code;
        } else {
            generalTracedCode(flagCode, originalCode, containerList);
        }
        return flagCode + originalCode;

    }

    /**
     * 生成不重复的用户账号
     * @return
     */
    public static String getCommonRandomCode(){
        long nowDate = System.currentTimeMillis();
        StringBuffer ssb = new StringBuffer();
        String sid = Integer.toHexString((int)nowDate);
        List<String> arrayList = Arrays.asList(sid.split(""));
        for(int i = 0; i < arrayList.size(); i++){
            String tmp = arrayList.get(i);
            if(!StrUtil.isNumeric(tmp)){
                for (int j = 0; j <ASCII_WORD.length ; j++) {
                    String inner = ASCII_WORD[j];
                    if(tmp.equalsIgnoreCase(inner)){
                        ssb.append(ASCII_NUM[j]/10);
                    }
                }
            }else{
                ssb.append(tmp);
            }
        }
        return ssb.toString();
    }

//    public static void main(String[] args) {
//        long nowDate = System.currentTimeMillis();
//        StringBuffer ssb = new StringBuffer();
//        String sid = Integer.toHexString((int)nowDate);
//        List<String> arrayList = Arrays.asList(sid.split(""));
//        for(int i = 0; i < arrayList.size(); i++){
//            String tmp = arrayList.get(i);
//            if(!StrUtil.isNumeric(tmp)){
//                for (int j = 0; j <ASCII_WORD.length ; j++) {
//                    String inner = ASCII_WORD[j];
//                    if(tmp.equalsIgnoreCase(inner)){
//                        ssb.append(ASCII_NUM[j]/10);
//                    }
//                }
//            }else{
//                ssb.append(tmp);
//            }
//
//        }
//        System.out.println(ssb.toString());
//
//    }
}
