
package com.hcloud.microserver.commoncore.util.build;

import com.hcloud.microserver.commoncore.util.DateUtils;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * @author JYJ
 */
public class BuildTools {
    /**
     * 补丁文件,由eclipse svn plugin生成
     */
    public static String patchFile = "E:\\increment-release\\patch.txt";
    /**
     * 补丁文件,由SVN的Show log->Copy to clipboard->Parhs relative to root生成
     */
    public static String svnPatchFile = "E:\\increment-release\\patch.txt";
    /**
     * 项目文件夹路径
     */
    public static String projectPath = "F:\\01 刘力源的文档\\workspace\\carbon";

    public static String buildPath = "ROOT";
    /**
     * web应用文件夹名
     */
    public static String webContent = "src/main/resources";
    /**
     * class存放路径
     */
    public static String classPath = "F:\\01 刘力源的文档\\workspace\\carbon\\target\\classes";
    /**
     * 补丁文件包存放路径
     */
    public static String desPath = "E:\\increment-release";
    /**
     * 项目名称
     */
    public static String svnProjectName = "carbon";


    /**
     * @param args
     * @throws Exception
     */
//	public static void main(String[] args) throws Exception {
//		//System.out.println(getPatchFileList());
//		//copyFilesForMaven(getPatchFileListFromSVNPatch());
//		copyFilesForMaven(getPatchFileList());
//	}

    /****
     * 读取补丁配置文件解析出修改的文件并返回到list集合
     * @return
     * @throws Exception
     */
    public static List<String> getPatchFileList() throws Exception {
        List<String> fileList = new ArrayList<String>();
        FileInputStream f = new FileInputStream(patchFile);
        BufferedReader dr = new BufferedReader(new InputStreamReader(f, "utf-8"));
        String line;
        while ((line = dr.readLine()) != null) {
            if (line.indexOf("Index:") != -1 && line.indexOf("Index:") == 0) {
                line = line.replaceAll(" ", "");
                line = line.substring(line.indexOf(":") + 1, line.length());
                fileList.add(line);
            }
        }
        dr.close();
        return fileList;
    }

    public static List<String> getPatchFileListFromSVNPatch() throws Exception {
        List<String> fileList = new ArrayList<String>();
        FileInputStream f = new FileInputStream(svnPatchFile);
        BufferedReader dr = new BufferedReader(new InputStreamReader(f, "utf-8"));
        String line;
        while ((line = dr.readLine()) != null) {
            if (line.indexOf(svnProjectName) != -1 && line.indexOf(".") != -1) {
                line = line.replaceAll(" ", "");
                line = line.substring(line.indexOf(svnProjectName) + svnProjectName.length() + 1, line.length());
                fileList.add(line);
            }
        }
        dr.close();
        return fileList;
    }

    /***
     *
     * @param list 修改的文件
     */
    public static void copyFilesForCommon(List<String> list) {
        String version = DateUtils.getShortYMDHMS();
        for (String fullFileName : list) {
            if (fullFileName.indexOf("src/") != -1) {//对源文件目录下的文件处理
                String fileName = fullFileName.replace("src", "");
                fullFileName = classPath + fileName;
                if (fileName.endsWith(".java")) {
                    fileName = fileName.replace(".java", ".class");
                    fullFileName = fullFileName.replace(".java", ".class");
                }
                String tempDesPath = fileName.substring(0, fileName.lastIndexOf("/"));
                String desFilePathStr = desPath + "/" + version + "/WEB-INF/classes" + tempDesPath;
                String desFileNameStr = desPath + "/" + version + "/WEB-INF/classes" + fileName;
                File desFilePath = new File(desFilePathStr);
                if (!desFilePath.exists()) {
                    desFilePath.mkdirs();
                }
                copyFile(fullFileName, desFileNameStr);
                System.out.println(fullFileName + "复制完成");
                //遍历目录，是否存在内部类，如果有内部，则将所有的额内部类挑选出来放到
                copyInnerClassFile(fullFileName, desFileNameStr);
            } else {//对普通目录的处理
                String desFileName = fullFileName.replaceAll(webContent, "");
                fullFileName = projectPath + "/" + fullFileName;//将要复制的文件全路径
                String fullDesFileNameStr = desPath + "/" + version + desFileName;
                String desFilePathStr = fullDesFileNameStr.substring(0, fullDesFileNameStr.lastIndexOf("/"));
                File desFilePath = new File(desFilePathStr);
                if (!desFilePath.exists()) {
                    desFilePath.mkdirs();
                }
                copyFile(fullFileName, fullDesFileNameStr);
                System.out.println(fullFileName + "复制完成");

            }

        }

    }

    public static void copyFilesForMaven(List<String> list) {
        String version = DateUtils.getShortYMDHMS();
        for (String fullFileName : list) {
            if (fullFileName.indexOf("src/main/java") != -1) {//对源文件目录下的文件处理
                String fileName = fullFileName.replace("src/main/java", "");
                fullFileName = classPath + fileName;
                if (fileName.endsWith(".java")) {
                    fileName = fileName.replace(".java", ".class");
                    fullFileName = fullFileName.replace(".java", ".class");
                }
                String tempDesPath = fileName.substring(0, fileName.lastIndexOf("/"));
                String desFilePathStr = desPath + "/" + version + "/ROOT/WEB-INF/classes" + tempDesPath;
                String desFileNameStr = desPath + "/" + version + "/ROOT/WEB-INF/classes" + fileName;
                File desFilePath = new File(desFilePathStr);
                if (!desFilePath.exists()) {
                    desFilePath.mkdirs();
                }
                copyFile(fullFileName, desFileNameStr);
                System.out.println(fullFileName + "复制完成");
                //遍历目录，是否存在内部类，如果有内部，则将所有的额内部类挑选出来放到
                copyInnerClassFile(fullFileName, desFileNameStr);
            } else if (fullFileName.indexOf("src/main/resources") != -1) {
                String fileName = fullFileName.replace("src/main/resources", "");
                fullFileName = classPath + fileName;
                String tempDesPath = fileName.substring(0, fileName.lastIndexOf("/"));
                String desFilePathStr = desPath + "/" + version + "/ROOT/WEB-INF/classes" + tempDesPath;
                String desFileNameStr = desPath + "/" + version + "/ROOT/WEB-INF/classes" + fileName;
                File desFilePath = new File(desFilePathStr);
                if (!desFilePath.exists()) {
                    desFilePath.mkdirs();
                }
                copyFile(fullFileName, desFileNameStr);
                System.out.println(fullFileName + "复制完成");
            } else {//对普通目录的处理
                String desFileName = fullFileName.replaceAll(webContent, "");
                fullFileName = projectPath + "/" + fullFileName;//将要复制的文件全路径
                String fullDesFileNameStr = desPath + "/" + version + "/ROOT" + desFileName;
                String desFilePathStr = fullDesFileNameStr.substring(0, fullDesFileNameStr.lastIndexOf("/"));
                File desFilePath = new File(desFilePathStr);
                if (!desFilePath.exists()) {
                    desFilePath.mkdirs();
                }
                copyFile(fullFileName, fullDesFileNameStr);
                System.out.println(fullFileName + "复制完成");

            }

        }

    }

    /***
     * 处理内部类的情况
     * 解析源路径名称，遍历此文件路径下是否存在这个类的内部类
     * 内部类编译后的格式一般是 OuterClassName$InnerClassName.class
     * @param sourceFullFileName 原路径
     * @param desFullFileName 目标路径
     */
    private static void copyInnerClassFile(String sourceFullFileName, String desFullFileName) {

        String sourceFileName = sourceFullFileName.substring(sourceFullFileName.lastIndexOf("/") + 1);
        String sourcePackPath = sourceFullFileName.substring(0, sourceFullFileName.lastIndexOf("/"));
        String destPackPath = desFullFileName.substring(0, desFullFileName.lastIndexOf("/"));
        String tempFileName = sourceFileName.split("\\.")[0];
        File packFile = new File(sourcePackPath);
        if (packFile.isDirectory()) {
            String[] listFiles = packFile.list();
            for (String fileName : listFiles) {
                //可以采用正则表达式处理
                if (fileName.indexOf(tempFileName + "$") > -1 && fileName.endsWith(".class")) {
                    String newSourceFullFileName = sourcePackPath + "/" + fileName;
                    String newDesFullFileName = destPackPath + "/" + fileName;
                    copyFile(newSourceFullFileName, newDesFullFileName);
                    System.out.println(newSourceFullFileName + "复制完成");
                }
            }
        }

    }

    private static void copyFile(String sourceFileNameStr, String desFileNameStr) {
        File srcFile = new File(sourceFileNameStr);
        File desFile = new File(desFileNameStr);
        try {
            copyFile(srcFile, desFile);
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    public static void copyFile(File sourceFile, File targetFile) throws IOException {
        BufferedInputStream inBuff = null;
        BufferedOutputStream outBuff = null;
        try {
            // 新建文件输入流并对它进行缓冲
            inBuff = new BufferedInputStream(new FileInputStream(sourceFile));

            // 新建文件输出流并对它进行缓冲
            outBuff = new BufferedOutputStream(new FileOutputStream(targetFile));

            // 缓冲数组
            byte[] b = new byte[1024 * 5];
            int len;
            while ((len = inBuff.read(b)) != -1) {
                outBuff.write(b, 0, len);
            }
            // 刷新此缓冲的输出流
            outBuff.flush();
        } finally {
            // 关闭流
            if (inBuff != null) {
                inBuff.close();
            }
            if (outBuff != null) {
                outBuff.close();
            }
        }
    }
}

 