package com.hcloud.microserver.commoncore.util.element;


import com.squareup.okhttp.*;
import org.apache.log4j.LogManager;
import org.apache.log4j.Logger;

import java.util.Map;

/**
 * 作用：发起一个http请求，使用okhttp请求，包含GET和POST请求
 * 作者：Tiddler
 * 时间：2018-08-2018/8/3 16：00
 * 类名：CreateRequest
 **/
public class CreateRequest {
    private final static Logger log= LogManager.getLogger(CreateRequest.class);

    private static final MediaType JSON = MediaType.parse("application/json; charset=utf-8");
    /**
     * GET请求一个地址，并且获取那个地址返回的页面文本
     * @param reqUrl
     * @return
     */
    public static String doGET(String reqUrl){
        if(reqUrl.indexOf("http")==-1){
            reqUrl="http://"+reqUrl;
        }
        String responseContext = null;
        OkHttpClient client = new OkHttpClient();
        //加入一些请求头信息，可以针对大多数做了防爬虫的网页
        Request request = new Request.Builder().url(reqUrl)
                .addHeader("User-Agent", "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36")
                .get()
                .build();
        try {
            Response response = client.newCall(request).execute();
//            log.debug(response.headers().size());
//            for(int i=0;i<response.headers().size();i++){
//                log.debug(response.headers().name(i)+"\t"+response.headers().get(response.headers().name(i)));
//            }
            byte[] bytes = response.body().bytes();
            responseContext = new String(bytes,"utf-8");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return responseContext;
    }

    public static String doPOST(String reqUrl,String jsonStr) throws Exception{
        if(reqUrl.indexOf("http")==-1){
            reqUrl="http://"+reqUrl;
        }
        String responseContext = null;
        OkHttpClient client = new OkHttpClient();
        RequestBody requestBody = RequestBody.create(JSON,jsonStr);
        Request request = new Request.Builder().url(reqUrl)
                .addHeader("User-Agent", "Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/75.0.3770.142 Safari/537.36")
                .put(requestBody)
                .build();
        Response response = client.newCall(request).execute();
        byte[] bytes = response.body().bytes();
        responseContext = new String(bytes,"utf-8");
        return responseContext;
    }

}