package com.hcloud.microserver.commoncore.util.string;

import org.apache.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * @author xiezt
 */
public class ConvertStringToList {

    public static List<String> getListFormSplitString(String str, String sep) {
        List<String> result = new ArrayList<>();
        if (null != str && !"".equals(str)) {
            if (str.indexOf(sep) != -1) {
                String[] splitStr = str.split(sep);
                result = Arrays.asList(splitStr);
            } else {
                result.add(str);
            }
        }
        return result;
    }

    public static String toXml(Map<String, String> params) {
        StringBuilder xml = new StringBuilder();
        xml.append("<xml>");
        for (Map.Entry<String, String> entry : params.entrySet()) {
            String key   = entry.getKey();
            String value = entry.getValue();
            // 略过空值
            if (StringUtils.isBlank(value)){ continue;}
            xml.append("<").append(key).append(">");
            xml.append(entry.getValue());
            xml.append("</").append(key).append(">");
        }
        xml.append("</xml>");
        return xml.toString();
    }
}
